#/bin/bash
RESULT_DIR=../results
MAX_N=100

mkdir -p ${RESULT_DIR}
echo "TRS input for c = 0 and n = 3"
cabal run -O2 pat-complete showTRS 0 3 
echo "-------------------------------"
echo "tree automata encoding for c = 0 and n = 3"
cabal run -O2 pat-complete showTA 0 3  # show Tree automata encoding for c = 0, n = 3
echo "-------------------------------"
echo "Haskell input for c = 0 and n = 3"
cabal run -O2 pat-complete showHS 0 3  # show Haskell input for c = 0, n = 3
echo "-------------------------------"
echo "running experiments with our algorithm"
cabal run -O2 pat-complete testOUR ${MAX_N} | tee ${RESULT_DIR}/results_OUR_haskell.txt
echo "-------------------------------"
echo "running experiments with GHC pattern completeness algorithm"
cabal run -O2 pat-complete testGHC ${MAX_N} | tee ${RESULT_DIR}/results_GHC_haskell.txt
echo "-------------------------------"
echo "running experiments with tree automata-encoding via FORT-h"
cabal run -O2 pat-complete testTA ${MAX_N} | tee ${RESULT_DIR}/results_TA_haskell.txt
