-- | Conversion from GTT to /RR2/ relation.
module RRn.GTT (
    fromGTT,
) where

import Prelude as P
import RRn.Type
import RRn.Internal
import qualified GTT
import qualified TA
import qualified Util.Set as S
import Util.Signature

-- | Root step construction from GTTs.
fromGTT :: (Ord f, Ord q) => Signature s f -> GTT.GTT f q -> RRn s f (Maybe q, Maybe q)
fromGTT sig GTT.GTT{ GTT.leftTA = la, GTT.rightTA = ra } = RRn {
    arity = 2,
    signature = sig,
    ta = (TA.map (\(f, g) -> [f, g]) id (prodAux la ra)) {
        TA.finals = P.map (\q -> jj q q) (S.toList (S.intersection ls rs))
    }
} where
    (ls, rs) = (TA.states la, TA.states ra)
    jj p q = (Just p, Just q)
