-- | /RRn/ relation type definition.
module RRn.Type (
    RRn (..),
    map
) where

import qualified TA
import Prelude hiding (map)
import Util.Signature

-- | An /RRn/ automaton.
data RRn s f q = RRn {
     arity :: Int,
     signature :: Signature s f,
     ta :: TA.TA [Maybe f] q
} deriving Show

-- | Map function symbols and states.
map :: (s -> s') -> (f -> f') -> (q -> q') -> RRn s f q -> RRn s' f' q'
map fs ff fq rrn = RRn {
    arity = arity rrn,
    signature = [(ff f, fs <$> ss, fs s) | (f, ss, s) <- signature rrn],
    ta = TA.map (fmap (fmap ff)) fq (ta rrn)
}
