-- | Annotated values.
module Util.Ann (
    Ann (..),
) where

-- | An annotated value; the annotation is ignored by comparisons.
--
-- This is useful for turning set-like containers into associative maps.
data Ann a b = Ann {
    value :: a,
    annotation ::  b
}

instance Eq a => Eq (Ann a b) where
    Ann a _ == Ann a' _ = a == a'

instance Ord a => Ord (Ann a b) where
    Ann a _ `compare` Ann a' _ = a `compare` a'
