-- | Parsec utilities.
module Util.Parsec (
    sysUnexpectedAt,
) where

import Text.Parsec

-- | Complain about unexpected input.
--
-- This is similar to `Text.Parsec.unexpected`, but one can specify the error
-- location and it produces a `Text.Parsec.Error.SysUnExpect` error which has
-- a higher priority than the ordinary `Text.Parsec.Error.UnExpect` error
-- produced by `Text.Parsec.unexpected`.
sysUnexpectedAt :: Stream s m t => SourcePos -> String -> ParsecT s u m a
sysUnexpectedAt p s = mkPT (\_ -> return $ Consumed (return $ sysUnExpectError s p))
