-- | Pretty printing utilities.
module Util.Pretty (
    encloseSep',
    nl,
) where

import Prettyprinter

-- | Variant of `encloseSep` that puts separators at the end of lines.
encloseSep' :: Doc ann -> Doc ann -> Doc ann -> [Doc ann] -> Doc ann
encloseSep' l r s ds = l <> nest 1 (cat (go ds)) where
    go [] = [r]
    go [d] = [d <> r]
    go (d:ds) = d <> s : go ds

-- | Vertical composition with a hard line break
nl :: Doc ann -> Doc ann -> Doc ann
d1 `nl` d2 = d1 <> hardline <> d2
