module Util.Signature where

import qualified Util.Set as S
import qualified Data.Map.Strict as M

type Signature s f = [(f, [s], s)]

arities :: Signature s f -> [(f, Int)]
arities sig = [(f, length ss) | (f, ss, _) <- sig]

sorts :: Ord s => Signature s f -> [s]
sorts sig = S.nubOrd $ concat [s:ss | (_, ss, s) <- sig]

lookupSig :: Ord f => Signature s f -> f -> ([s], s)
lookupSig sig = (sigM M.!)
    where
        sigM = M.fromList [(f, (ss, s)) | (f, ss, s) <- sig]

