module ArgumentParser where

import Text.Parsec

type ArgParser a = Parsec String () a

functionSymbolParser ::  Parsec String () String
functionSymbolParser =  many1 (noneOf "()\",|\\ \n") <* spaces

-- | parses a positive integer
-- <nat> <var> <term> <item> <itemref>
nat :: Parsec String () Int
nat = read <$> many1 digit <* spaces

signaturePairParser :: Parsec String () (String,Int)
signaturePairParser = do
    f <- functionSymbolParser 
    n <- nat
    return (f,n)

signatureParser :: Parsec String () [(String,Int)]
signatureParser = many signaturePairParser

intListParser :: Parsec String () [Int]
intListParser = many nat
