{-# LANGUAGE EmptyDataDecls, RankNTypes, ScopedTypeVariables #-}

module
  Pat_Test_Generated(Term, Char, encodeAutomata, showAutomata,
                      createHaskellInput, pat_complete_alg_test,
                      show_pat_complete_test, patCompleteAutomataTest)
  where {

import Prelude ((==), (/=), (<), (<=), (>=), (>), (+), (-), (*), (/), (**),
  (>>=), (>>), (=<<), (&&), (||), (^), (^^), (.), ($), ($!), (++), (!!), Eq,
  error, id, return, not, fst, snd, map, filter, concat, concatMap, reverse,
  zip, null, takeWhile, dropWhile, all, any, Integer, negate, abs, divMod,
  String, Bool(True, False), Maybe(Nothing, Just));
import qualified Prelude;

newtype Nat = Nat Integer;

integer_of_nat :: Nat -> Integer;
integer_of_nat (Nat x) = x;

equal_nat :: Nat -> Nat -> Bool;
equal_nat m n = integer_of_nat m == integer_of_nat n;

instance Eq Nat where {
  a == b = equal_nat a b;
};

times_nat :: Nat -> Nat -> Nat;
times_nat m n = Nat (integer_of_nat m * integer_of_nat n);

class Times a where {
  times :: a -> a -> a;
};

class (Times a) => Dvd a where {
};

instance Times Nat where {
  times = times_nat;
};

instance Dvd Nat where {
};

data Num = One | Bit0 Num | Bit1 Num;

one_nat :: Nat;
one_nat = Nat (1 :: Integer);

class One a where {
  one :: a;
};

instance One Nat where {
  one = one_nat;
};

plus_nat :: Nat -> Nat -> Nat;
plus_nat m n = Nat (integer_of_nat m + integer_of_nat n);

class Plus a where {
  plus :: a -> a -> a;
};

instance Plus Nat where {
  plus = plus_nat;
};

zero_nat :: Nat;
zero_nat = Nat (0 :: Integer);

class Zero a where {
  zero :: a;
};

instance Zero Nat where {
  zero = zero_nat;
};

class (Plus a) => Semigroup_add a where {
};

class (One a, Semigroup_add a) => Numeral a where {
};

instance Semigroup_add Nat where {
};

instance Numeral Nat where {
};

class (One a, Times a) => Power a where {
};

instance Power Nat where {
};

class Ord a where {
  less_eq :: a -> a -> Bool;
  less :: a -> a -> Bool;
};

max :: forall a. (Ord a) => a -> a -> a;
max a b = (if less_eq a b then b else a);

instance Ord Integer where {
  less_eq = (\ a b -> a <= b);
  less = (\ a b -> a < b);
};

minus_nat :: Nat -> Nat -> Nat;
minus_nat m n = Nat (max (0 :: Integer) (integer_of_nat m - integer_of_nat n));

class Minus a where {
  minus :: a -> a -> a;
};

instance Minus Nat where {
  minus = minus_nat;
};

apsnd :: forall a b c. (a -> b) -> (c, a) -> (c, b);
apsnd f (x, y) = (x, f y);

divmod_integer :: Integer -> Integer -> (Integer, Integer);
divmod_integer k l =
  (if k == (0 :: Integer) then ((0 :: Integer), (0 :: Integer))
    else (if (0 :: Integer) < l
           then (if (0 :: Integer) < k then divMod (abs k) (abs l)
                  else (case divMod (abs k) (abs l) of {
                         (r, s) ->
                           (if s == (0 :: Integer)
                             then (negate r, (0 :: Integer))
                             else (negate r - (1 :: Integer), l - s));
                       }))
           else (if l == (0 :: Integer) then ((0 :: Integer), k)
                  else apsnd negate
                         (if k < (0 :: Integer) then divMod (abs k) (abs l)
                           else (case divMod (abs k) (abs l) of {
                                  (r, s) ->
                                    (if s == (0 :: Integer)
                                      then (negate r, (0 :: Integer))
                                      else (negate r - (1 :: Integer),
     negate l - s));
                                })))));

divide_integer :: Integer -> Integer -> Integer;
divide_integer k l = fst (divmod_integer k l);

divide_nat :: Nat -> Nat -> Nat;
divide_nat m n = Nat (divide_integer (integer_of_nat m) (integer_of_nat n));

class Divide a where {
  divide :: a -> a -> a;
};

instance Divide Nat where {
  divide = divide_nat;
};

modulo_integer :: Integer -> Integer -> Integer;
modulo_integer k l = snd (divmod_integer k l);

modulo_nat :: Nat -> Nat -> Nat;
modulo_nat m n = Nat (modulo_integer (integer_of_nat m) (integer_of_nat n));

class (Divide a, Dvd a) => Modulo a where {
  modulo :: a -> a -> a;
};

instance Modulo Nat where {
  modulo = modulo_nat;
};

less_eq_nat :: Nat -> Nat -> Bool;
less_eq_nat m n = integer_of_nat m <= integer_of_nat n;

less_nat :: Nat -> Nat -> Bool;
less_nat m n = integer_of_nat m < integer_of_nat n;

instance Ord Nat where {
  less_eq = less_eq_nat;
  less = less_nat;
};

class (Semigroup_add a) => Ab_semigroup_add a where {
};

class (Semigroup_add a, Zero a) => Monoid_add a where {
};

class (Ab_semigroup_add a, Monoid_add a) => Comm_monoid_add a where {
};

class (Times a, Zero a) => Mult_zero a where {
};

class (Times a) => Semigroup_mult a where {
};

class (Ab_semigroup_add a, Semigroup_mult a) => Semiring a where {
};

class (Comm_monoid_add a, Mult_zero a, Semiring a) => Semiring_0 a where {
};

class (Semiring_0 a) => Semiring_no_zero_divisors a where {
};

class (Semigroup_mult a, Power a) => Monoid_mult a where {
};

class (Monoid_mult a, Numeral a, Semiring a) => Semiring_numeral a where {
};

class (One a, Zero a) => Zero_neq_one a where {
};

class (Semiring_numeral a, Semiring_0 a, Zero_neq_one a) => Semiring_1 a where {
};

class (Semiring_1 a,
        Semiring_no_zero_divisors a) => Semiring_1_no_zero_divisors a where {
};

class (Semigroup_add a) => Cancel_semigroup_add a where {
};

class (Ab_semigroup_add a, Cancel_semigroup_add a,
        Minus a) => Cancel_ab_semigroup_add a where {
};

class (Cancel_ab_semigroup_add a,
        Comm_monoid_add a) => Cancel_comm_monoid_add a where {
};

class (Cancel_comm_monoid_add a, Semiring_0 a) => Semiring_0_cancel a where {
};

class (Semigroup_mult a) => Ab_semigroup_mult a where {
};

class (Ab_semigroup_mult a, Semiring a) => Comm_semiring a where {
};

class (Comm_semiring a, Semiring_0 a) => Comm_semiring_0 a where {
};

class (Comm_semiring_0 a,
        Semiring_0_cancel a) => Comm_semiring_0_cancel a where {
};

class (Semiring_0_cancel a, Semiring_1 a) => Semiring_1_cancel a where {
};

class (Ab_semigroup_mult a, Monoid_mult a, Dvd a) => Comm_monoid_mult a where {
};

class (Comm_monoid_mult a, Comm_semiring_0 a,
        Semiring_1 a) => Comm_semiring_1 a where {
};

class (Comm_semiring_0_cancel a, Comm_semiring_1 a,
        Semiring_1_cancel a) => Comm_semiring_1_cancel a where {
};

class (Comm_semiring_1_cancel a,
        Semiring_1_no_zero_divisors a) => Semidom a where {
};

instance Ab_semigroup_add Nat where {
};

instance Monoid_add Nat where {
};

instance Comm_monoid_add Nat where {
};

instance Mult_zero Nat where {
};

instance Semigroup_mult Nat where {
};

instance Semiring Nat where {
};

instance Semiring_0 Nat where {
};

instance Semiring_no_zero_divisors Nat where {
};

instance Monoid_mult Nat where {
};

instance Semiring_numeral Nat where {
};

instance Zero_neq_one Nat where {
};

instance Semiring_1 Nat where {
};

instance Semiring_1_no_zero_divisors Nat where {
};

instance Cancel_semigroup_add Nat where {
};

instance Cancel_ab_semigroup_add Nat where {
};

instance Cancel_comm_monoid_add Nat where {
};

instance Semiring_0_cancel Nat where {
};

instance Ab_semigroup_mult Nat where {
};

instance Comm_semiring Nat where {
};

instance Comm_semiring_0 Nat where {
};

instance Comm_semiring_0_cancel Nat where {
};

instance Semiring_1_cancel Nat where {
};

instance Comm_monoid_mult Nat where {
};

instance Comm_semiring_1 Nat where {
};

instance Comm_semiring_1_cancel Nat where {
};

instance Semidom Nat where {
};

class (Semiring_no_zero_divisors a) => Semiring_no_zero_divisors_cancel a where {
};

class (Divide a, Semidom a,
        Semiring_no_zero_divisors_cancel a) => Semidom_divide a where {
};

instance Semiring_no_zero_divisors_cancel Nat where {
};

instance Semidom_divide Nat where {
};

class (Semidom_divide a) => Algebraic_semidom a where {
};

class (Comm_semiring_1_cancel a, Modulo a) => Semiring_modulo a where {
};

class (Algebraic_semidom a, Semiring_modulo a) => Semidom_modulo a where {
};

instance Algebraic_semidom Nat where {
};

instance Semiring_modulo Nat where {
};

instance Semidom_modulo Nat where {
};

class Showl a where {
  showsl :: a -> String -> String;
  showsl_list :: [a] -> String -> String;
};

showsl_lista :: forall a. (Showl a) => [a] -> String -> String;
showsl_lista xs = showsl_list xs;

showsl_lit :: String -> String -> String;
showsl_lit = (\ a b -> a ++ b);

showsl_sep ::
  forall a.
    (a -> String -> String) -> (String -> String) -> [a] -> String -> String;
showsl_sep s sep [] = showsl_lit "";
showsl_sep s sep [x] = s x;
showsl_sep s sep (x : v : va) = (s x . sep) . showsl_sep s sep (v : va);

showsl_list_gen ::
  forall a.
    (a -> String -> String) ->
      String -> String -> String -> String -> [a] -> String -> String;
showsl_list_gen showslx e l s r xs =
  (if null xs then showsl_lit e
    else (showsl_lit l . showsl_sep showslx (showsl_lit s) xs) . showsl_lit r);

default_showsl_list ::
  forall a. (a -> String -> String) -> [a] -> String -> String;
default_showsl_list sl = showsl_list_gen sl "[]" "[" ", " "]";

showsl_list_list :: forall a. (Showl a) => [[a]] -> String -> String;
showsl_list_list xs = default_showsl_list showsl_lista xs;

instance (Showl a) => Showl [a] where {
  showsl = showsl_lista;
  showsl_list = showsl_list_list;
};

data Term a b = Var b | Fun a [Term a b];

showsl_term ::
  forall a b.
    (a -> String -> String) ->
      (b -> String -> String) -> Term a b -> String -> String;
showsl_term fun var (Var x) = var x;
showsl_term fun var (Fun f ts) =
  fun f . showsl_list_gen id "" "(" ", " ")" (map (showsl_term fun var) ts);

showsl_terma :: forall a b. (Showl a, Showl b) => Term a b -> String -> String;
showsl_terma t = showsl_term showsl showsl t;

showsl_list_term ::
  forall a b. (Showl a, Showl b) => [Term a b] -> String -> String;
showsl_list_term xs = default_showsl_list showsl_terma xs;

instance (Showl a, Showl b) => Showl (Term a b) where {
  showsl = showsl_terma;
  showsl_list = showsl_list_term;
};

newtype Char = Chr Integer;

integer_of_char :: Char -> Integer;
integer_of_char (Chr x) = x;

equal_char :: Char -> Char -> Bool;
equal_char c d = integer_of_char c == integer_of_char d;

instance Eq Char where {
  a == b = equal_char a b;
};

implode :: [Char] -> String;
implode cs =
  map (let chr k | (0 <= k && k < 128) = Prelude.toEnum k :: Prelude.Char in chr . Prelude.fromInteger)
    (map integer_of_char cs);

showsl_list_char :: [Char] -> String -> String;
showsl_list_char cs s = showsl_lit (implode cs) s;

showsl_char :: Char -> String -> String;
showsl_char c = showsl_lit (implode [c]);

instance Showl Char where {
  showsl = showsl_char;
  showsl_list = showsl_list_char;
};

data Set a = Set [a] | Coset [a];

data Sum a b = Inl a | Inr b;

suc :: Nat -> Nat;
suc n = plus_nat n one_nat;

nth :: forall a. [a] -> Nat -> a;
nth (x : xs) n =
  (if equal_nat n zero_nat then x else nth xs (minus_nat n one_nat));

upt :: Nat -> Nat -> [Nat];
upt i j = (if less_nat i j then i : upt (suc i) j else []);

find :: forall a. (a -> Bool) -> [a] -> Maybe a;
find uu [] = Nothing;
find p (x : xs) = (if p x then Just x else find p xs);

fold :: forall a b. (a -> b -> b) -> [a] -> b -> b;
fold f (x : xs) s = fold f xs (f x s);
fold f [] s = s;

foldr :: forall a b. (a -> b -> b) -> [a] -> b -> b;
foldr f [] = id;
foldr f (x : xs) = f x . foldr f xs;

map_option :: forall a b. (a -> b) -> Maybe a -> Maybe b;
map_option f Nothing = Nothing;
map_option f (Just x2) = Just (f x2);

those :: forall a. [Maybe a] -> Maybe [a];
those [] = Just [];
those (x : xs) = (case x of {
                   Nothing -> Nothing;
                   Just y -> map_option (\ a -> y : a) (those xs);
                 });

map_of :: forall a b. (Eq a) => [(a, b)] -> a -> Maybe b;
map_of ((l, v) : ps) k = (if l == k then Just v else map_of ps k);
map_of [] k = Nothing;

removeAll :: forall a. (Eq a) => a -> [a] -> [a];
removeAll x [] = [];
removeAll x (y : xs) = (if x == y then removeAll x xs else y : removeAll x xs);

membera :: forall a. (Eq a) => [a] -> a -> Bool;
membera [] y = False;
membera (x : xs) y = x == y || membera xs y;

inserta :: forall a. (Eq a) => a -> [a] -> [a];
inserta x xs = (if membera xs x then xs else x : xs);

insert :: forall a. (Eq a) => a -> Set a -> Set a;
insert x (Coset xs) = Coset (removeAll x xs);
insert x (Set xs) = Set (inserta x xs);

member :: forall a. (Eq a) => a -> Set a -> Bool;
member x (Coset xs) = not (membera xs x);
member x (Set xs) = membera xs x;

remove :: forall a. (Eq a) => a -> Set a -> Set a;
remove x (Coset xs) = Coset (inserta x xs);
remove x (Set xs) = Set (removeAll x xs);

fun_upd :: forall a b. (Eq a) => (a -> b) -> a -> b -> a -> b;
fun_upd f a b = (\ x -> (if x == a then b else f x));

subst :: forall a b. (Eq a) => a -> Term b a -> a -> Term b a;
subst x t = fun_upd Var x t;

update :: forall a b. (Eq a) => a -> b -> [(a, b)] -> [(a, b)];
update k v [] = [(k, v)];
update k v (p : ps) = (if fst p == k then (k, v) : ps else p : update k v ps);

hd :: forall a. [a] -> a;
hd (x21 : x22) = x21;

tl :: forall a. [a] -> [a];
tl [] = [];
tl (x21 : x22) = x22;

remdups :: forall a. (Eq a) => [a] -> [a];
remdups [] = [];
remdups (x : xs) = (if membera xs x then remdups xs else x : remdups xs);

distinct :: forall a. (Eq a) => [a] -> Bool;
distinct [] = True;
distinct (x : xs) = not (membera xs x) && distinct xs;

partition :: forall a. (a -> Bool) -> [a] -> ([a], [a]);
partition p [] = ([], []);
partition p (x : xs) =
  (case partition p xs of {
    (yes, no) -> (if p x then (x : yes, no) else (yes, x : no));
  });

replicate :: forall a. Nat -> a -> [a];
replicate n x =
  (if equal_nat n zero_nat then [] else x : replicate (minus_nat n one_nat) x);

eval_term :: forall a b c. (a -> [b] -> b) -> Term a c -> (c -> b) -> b;
eval_term i (Var x) alpha = alpha x;
eval_term i (Fun f ss) alpha = i f (map (\ s -> eval_term i s alpha) ss);

gen_length :: forall a. Nat -> [a] -> Nat;
gen_length n (x : xs) = gen_length (suc n) xs;
gen_length n [] = n;

map_filter :: forall a b. (a -> Maybe b) -> [a] -> [b];
map_filter f [] = [];
map_filter f (x : xs) = (case f x of {
                          Nothing -> map_filter f xs;
                          Just y -> y : map_filter f xs;
                        });

bind :: forall a b c. Sum a b -> (b -> Sum a c) -> Sum a c;
bind m f = (case m of {
             Inl a -> Inl a;
             Inr a -> f a;
           });

max_list :: [Nat] -> Nat;
max_list [] = zero_nat;
max_list (x : xs) = max x (max_list xs);

check :: forall a. Bool -> a -> Sum a ();
check b e = (if b then Inr () else Inl e);

the :: forall a. Maybe a -> a;
the (Just x2) = x2;

shows_string :: [Char] -> [Char] -> [Char];
shows_string = (\ a b -> a ++ b);

catch_error :: forall a b c. Sum a b -> (a -> Sum c b) -> Sum c b;
catch_error m f = (case m of {
                    Inl a -> f a;
                    Inr a -> Inr a;
                  });

forallM :: forall a b. (a -> Sum b ()) -> [a] -> Sum (a, b) ();
forallM f [] = Inr ();
forallM f (x : xs) =
  bind (catch_error (f x) (\ xa -> Inl (x, xa))) (\ _ -> forallM f xs);

dvd :: forall a. (Eq a, Semidom_modulo a) => a -> a -> Bool;
dvd a b = modulo b a == zero;

g :: forall a. (String -> Integer -> a) -> Integer -> a;
g cSym n = cSym "g" ((2 :: Integer) * n);

ff :: forall a. (String -> Integer -> a) -> a;
ff cSym = cSym "ff" (0 :: Integer);

qb :: forall a. (String -> a) -> a;
qb cState = cState "qb";

qf :: forall a. (String -> a) -> a;
qf cState = cState "qf";

qt :: forall a. (String -> a) -> a;
qt cState = cState "qt";

tt :: forall a. (String -> Integer -> a) -> a;
tt cSym = cSym "tt" (0 :: Integer);

map_prod :: forall a b c d. (a -> b) -> (c -> d) -> (a, c) -> (b, d);
map_prod f g (a, b) = (f a, g b);

qfin :: forall a. (String -> a) -> a;
qfin cState = cState "qFin";

add_vars_term :: forall a b. Term a b -> [b] -> [b];
add_vars_term (Var x) xs = x : xs;
add_vars_term (Fun uu ts) xs = foldr add_vars_term ts xs;

fRule ::
  forall a b c. (String -> Integer -> a) -> (a -> [b] -> b -> c) -> b -> c;
fRule cSym cRule = cRule (ff cSym) [];

paren :: String -> String -> String -> String -> [String] -> String;
paren e l r s [] = e;
paren e l r s (x : xs) = l ++ x ++ foldr (\ y ra -> s ++ y ++ ra) xs r;

tRule ::
  forall a b c. (String -> Integer -> a) -> (a -> [b] -> b -> c) -> b -> c;
tRule cSym cRule = cRule (tt cSym) [];

bot_set :: forall a. Set a;
bot_set = Set [];

sup_set :: forall a. (Eq a) => Set a -> Set a -> Set a;
sup_set (Coset xs) a = Coset (filter (\ x -> not (member x a)) xs);
sup_set (Set xs) a = fold insert xs a;

vars_term_list :: forall a b. Term a b -> [b];
vars_term_list t = add_vars_term t [];

char_0x39 :: Char;
char_0x39 = Chr (57 :: Integer);

char_0x38 :: Char;
char_0x38 = Chr (56 :: Integer);

char_0x37 :: Char;
char_0x37 = Chr (55 :: Integer);

char_0x36 :: Char;
char_0x36 = Chr (54 :: Integer);

char_0x35 :: Char;
char_0x35 = Chr (53 :: Integer);

char_0x34 :: Char;
char_0x34 = Chr (52 :: Integer);

char_0x33 :: Char;
char_0x33 = Chr (51 :: Integer);

char_0x32 :: Char;
char_0x32 = Chr (50 :: Integer);

char_0x31 :: Char;
char_0x31 = Chr (49 :: Integer);

char_0x30 :: Char;
char_0x30 = Chr (48 :: Integer);

nat_of_integer :: Integer -> Nat;
nat_of_integer k = Nat (max (0 :: Integer) k);

string_of_digit :: Nat -> [Char];
string_of_digit n =
  (if equal_nat n zero_nat then [char_0x30]
    else (if equal_nat n one_nat then [char_0x31]
           else (if equal_nat n (nat_of_integer (2 :: Integer)) then [char_0x32]
                  else (if equal_nat n (nat_of_integer (3 :: Integer))
                         then [char_0x33]
                         else (if equal_nat n (nat_of_integer (4 :: Integer))
                                then [char_0x34]
                                else (if equal_nat n
   (nat_of_integer (5 :: Integer))
                                       then [char_0x35]
                                       else (if equal_nat n
          (nat_of_integer (6 :: Integer))
      then [char_0x36]
      else (if equal_nat n (nat_of_integer (7 :: Integer)) then [char_0x37]
             else (if equal_nat n (nat_of_integer (8 :: Integer))
                    then [char_0x38] else [char_0x39])))))))));

showsp_nat :: Nat -> Nat -> [Char] -> [Char];
showsp_nat p n =
  (if less_nat n (nat_of_integer (10 :: Integer))
    then shows_string (string_of_digit n)
    else showsp_nat p (divide_nat n (nat_of_integer (10 :: Integer))) .
           shows_string
             (string_of_digit (modulo_nat n (nat_of_integer (10 :: Integer)))));

qbRules ::
  forall a b c.
    (String -> a) -> (String -> Integer -> b) -> (b -> [a] -> a -> c) -> [c];
qbRules cState cSym cRule =
  [tRule cSym cRule (qb cState), fRule cSym cRule (qb cState)];

showsl_lines :: forall a. (Showl a) => String -> [a] -> String -> String;
showsl_lines desc_empty = showsl_list_gen showsl desc_empty "" "\n" "";

stdRules ::
  forall a b c.
    (String -> a) -> (String -> Integer -> b) -> (b -> [a] -> a -> c) -> [c];
stdRules cState cSym cRule =
  qbRules cState cSym cRule ++
    [tRule cSym cRule (qt cState), fRule cSym cRule (qf cState)];

finStates :: forall a. (String -> a) -> [a];
finStates cState = [qfin cState];

signature :: forall a. (String -> Integer -> a) -> Integer -> [a];
signature cSym n = [tt cSym, ff cSym, g cSym n];

char_0x62 :: Char;
char_0x62 = Chr (98 :: Integer);

char_0x66 :: Char;
char_0x66 = Chr (102 :: Integer);

char_0x67 :: Char;
char_0x67 = Chr (103 :: Integer);

char_0x74 :: Char;
char_0x74 = Chr (116 :: Integer);

char_0x78 :: Char;
char_0x78 = Chr (120 :: Integer);

char_0x79 :: Char;
char_0x79 = Chr (121 :: Integer);

minus_set :: forall a. (Eq a) => Set a -> Set a -> Set a;
minus_set a (Coset xs) = Set (filter (\ x -> member x a) xs);
minus_set a (Set xs) = fold remove xs a;

less_eq_set :: forall a. (Eq a) => Set a -> Set a -> Bool;
less_eq_set (Coset []) (Set []) = False;
less_eq_set a (Coset ys) = all (\ y -> not (member y a)) ys;
less_eq_set (Set xs) b = all (\ x -> member x b) xs;

argToState :: forall a b. (String -> a) -> Term [Char] b -> a;
argToState cState (Var uu) = qb cState;
argToState cState (Fun s []) =
  (if s == [char_0x74, char_0x74] then qt cState
    else (if s == [char_0x66, char_0x66] then qf cState
           else (error :: forall a. String -> (() -> a) -> a) "unknown"
                  (\ _ -> qf cState)));

leftStates :: forall a. (String -> a) -> [a];
leftStates cState = [qb cState, qfin cState];

termToRule ::
  forall a b c d.
    (String -> a) ->
      (String -> Integer -> b) ->
        (b -> [a] -> a -> c) -> Integer -> Term [Char] d -> c;
termToRule cState cSym cRule n (Fun uu ts) =
  cRule (g cSym n) (map (argToState cState) ts) (qfin cState);

size_list :: forall a. [a] -> Nat;
size_list = gen_length zero_nat;

rightStates :: forall a. (String -> a) -> [a];
rightStates cState = [qt cState, qf cState] ++ leftStates cState;

shows_prec_nat :: Nat -> Nat -> [Char] -> [Char];
shows_prec_nat = showsp_nat;

testproblem ::
  Nat ->
    Nat ->
      ([(([Char], [[Char]]), [Char])],
        ([(([Char], [[Char]]), [Char])], [Term [Char] [Char]]));
testproblem c n =
  let {
    _ = implode;
    s = id;
    c1 = dvd (nat_of_integer (2 :: Integer)) c;
    c2 = dvd (nat_of_integer (2 :: Integer))
           (divide_nat c (nat_of_integer (2 :: Integer)));
    c3 = dvd (nat_of_integer (2 :: Integer))
           (divide_nat c (nat_of_integer (4 :: Integer)));
    c4 = dvd (nat_of_integer (2 :: Integer))
           (divide_nat c (nat_of_integer (8 :: Integer)));
    revo = (if c4 then id else reverse);
    nn = upt zero_nat n;
    rnn = (if c4 then id nn else reverse nn);
    b = s [char_0x62];
    t = s [char_0x74, char_0x74];
    f = s [char_0x66, char_0x66];
    g = s [char_0x67];
    gg = (\ ts -> Fun g (revo ts));
    ff = Fun f [];
    tt = Fun t [];
    ca = [((t, []), b), ((f, []), b)];
    d = [((g, replicate (times_nat (nat_of_integer (2 :: Integer)) n) b), b)];
    x = (\ i -> Var (s ([char_0x78] ++ shows_prec_nat zero_nat i [])));
    y = (\ i -> Var (s ([char_0x79] ++ shows_prec_nat zero_nat i [])));
    lhsF =
      gg (if c1 then concatMap (\ i -> [ff, y i]) rnn
           else replicate n ff ++ map y rnn);
    lhsT =
      (\ ba j ->
        gg (if c1
             then concatMap
                    (\ i -> (if equal_nat i j then [tt, ba] else [x i, y i]))
                    rnn
             else map (\ i -> (if equal_nat i j then tt else x i)) rnn ++
                    map (\ i -> (if equal_nat i j then ba else y i)) rnn));
    lhssT =
      (if c2 then concatMap (\ i -> [lhsT tt i, lhsT ff i]) nn
        else concatMap (\ ba -> map (lhsT ba) nn) [tt, ff]);
    lhss = (if c3 then [lhsF] ++ lhssT else lhssT ++ [lhsF]);
  } in (ca, (d, lhss));

automataLeft ::
  forall a b c d.
    (String -> a) ->
      (String -> Integer -> b) ->
        (b -> [a] -> a -> c) -> ([b] -> [a] -> [a] -> [c] -> d) -> Integer -> d;
automataLeft cState cSym cRule cAut n =
  cAut (signature cSym n) (leftStates cState) (finStates cState)
    (cRule (g cSym n)
       (replicate (times_nat (nat_of_integer (2 :: Integer)) (nat_of_integer n))
         (qb cState))
       (qfin cState) :
      qbRules cState cSym cRule);

test_problem ::
  Nat ->
    Nat ->
      [([Nat], [Nat])] ->
        ([(([Char], [[Char]]), [Char])],
          ([(([Char], [[Char]]), [Char])], [Term [Char] [Char]]));
test_problem c n perms =
  (if less_nat c (nat_of_integer (16 :: Integer)) then testproblem c n
    else (case testproblem zero_nat n of {
           (ca, (d, lhss)) ->
             (case nth perms (minus_nat c (nat_of_integer (16 :: Integer))) of {
               (permRow, permCol) ->
                 let {
                   permRows = map (nth lhss) permRow;
                   pCol = (\ (Fun g ts) -> Fun g (map (nth ts) permCol));
                 } in (ca, (d, map pCol permRows));
             });
         }));

test_problem_integer ::
  Integer ->
    Integer ->
      [([Integer], [Integer])] ->
        ([(([Char], [[Char]]), [Char])],
          ([(([Char], [[Char]]), [Char])], [Term [Char] [Char]]));
test_problem_integer c n perms =
  test_problem (nat_of_integer c) (nat_of_integer n)
    (map (map_prod (map nat_of_integer) (map nat_of_integer)) perms);

automataRight ::
  forall a b c d.
    (String -> a) ->
      (String -> Integer -> b) ->
        (b -> [a] -> a -> c) ->
          ([b] -> [a] -> [a] -> [c] -> d) ->
            Integer -> Integer -> [([Integer], [Integer])] -> d;
automataRight cState cSym cRule cAut c n perms =
  (case test_problem_integer c n perms of {
    (_, (_, lhss)) ->
      cAut (signature cSym n) (rightStates cState) (finStates cState)
        (map (termToRule cState cSym cRule n) lhss ++
          stdRules cState cSym cRule);
  });

encodeAutomata ::
  forall a b c d.
    (String -> a) ->
      (String -> Integer -> b) ->
        (b -> [a] -> a -> c) ->
          ([b] -> [a] -> [a] -> [c] -> d) ->
            Integer -> Integer -> [([Integer], [Integer])] -> (d, d);
encodeAutomata cState cSym cRule cAut c n perms =
  (automataLeft cState cSym cRule cAut n,
    automataRight cState cSym cRule cAut c n perms);

showAutomata :: Integer -> Integer -> [([Integer], [Integer])] -> String;
showAutomata n c perms =
  (case encodeAutomata id (\ na _ -> na)
          (\ f qs q -> paren f (f ++ "(") ")" "," qs ++ " -> " ++ q)
          (\ _ _ qfin rls ->
            "tree-automata has final states: " ++
              paren "{}" "{" "}" "," qfin ++
                "\n" ++
                  "and transitions:\n" ++ paren "" "" "" "\n" rls ++ "\n\n")
          n c perms
    of {
    (alla, pats) ->
      "decide whether language of first automaton is subset of the second automaton\n\n" ++
        "first " ++ alla ++ "\nand second " ++ pats;
  });

tau_c ::
  forall a b.
    (Eq a) => Nat -> (Nat, a) -> (b, [a]) -> (Nat, a) -> Term b (Nat, a);
tau_c n x c =
  (case c of {
    (f, ss) ->
      subst x (Fun f (map Var (zip (upt n (plus_nat n (size_list ss))) ss)));
  });

term_to_haskell :: Term [Char] [Char] -> String;
term_to_haskell (Var x) = implode x;
term_to_haskell (Fun f ts) =
  (if f == [char_0x74, char_0x74] then "TT"
    else (if f == [char_0x66, char_0x66] then "FF" else implode f)) ++
    foldr (\ t -> (\ a -> (" " ++ term_to_haskell t) ++ a)) ts "";

empty_lr ::
  forall a b c.
    ([((Nat, a), Term b c)], ([(c, [Term b (Nat, a)])], Bool)) -> Bool;
empty_lr mp = (case mp of {
                (lx, (rx, _)) -> null lx && null rx;
              });

conflicts :: forall a b. (Eq a, Eq b) => Term a b -> Term a b -> Maybe [b];
conflicts (Var x) (Var y) = (if x == y then Just [] else Just [x, y]);
conflicts (Var x) (Fun uu uv) = Just [x];
conflicts (Fun uw ux) (Var x) = Just [x];
conflicts (Fun f ss) (Fun g ts) =
  (if (f, size_list ss) == (g, size_list ts)
    then map_option concat (those (map (\ (a, b) -> conflicts a b) (zip ss ts)))
    else Nothing);

find_var ::
  forall a b c.
    (Eq a,
      Eq b) => [([((Nat, a), Term b c)], ([(c, [Term b (Nat, a)])], Bool))] ->
                 (Nat, a);
find_var p =
  (case concatMap (\ (lx, _) -> lx) p of {
    [] -> (case hd (filter ((not . snd) . snd) p) of {
            (_, (rx, _)) -> (case hd rx of {
                              (_, s : t : _) -> hd (the (conflicts s t));
                            });
          });
    (x, _) : _ -> x;
  });

compute_nonempty_main ::
  forall a b. (Eq a) => Set a -> [((b, [a]), a)] -> Set a;
compute_nonempty_main ne ls =
  let {
    rem_ls = filter (\ f -> not (member (snd f) ne)) ls;
  } in (case partition
               (\ (a, b) ->
                 (case a of {
                   (_, args) -> (\ _ -> less_eq_set (Set args) ne);
                 })
                   b)
               rem_ls
         of {
         (new, rem) ->
           (if null new then ne
             else compute_nonempty_main (sup_set ne (Set (map snd new))) rem);
       });

compute_nonempty_sorts :: forall a b. (Eq b) => [((a, [b]), b)] -> Set b;
compute_nonempty_sorts cs = compute_nonempty_main bot_set cs;

decide_nonempty_sorts ::
  forall a b. (Eq a) => [a] -> [((b, [a]), a)] -> Maybe a;
decide_nonempty_sorts tau_s cs = let {
                                   ne = compute_nonempty_sorts cs;
                                 } in find (\ tau -> not (member tau ne)) tau_s;

tau_s_list ::
  forall a b.
    (Eq a) => (a -> [(b, [a])]) ->
                Nat -> (Nat, a) -> [(Nat, a) -> Term b (Nat, a)];
tau_s_list cl n x = map (tau_c n x) (cl (snd x));

insert_rx ::
  forall a b c.
    (Eq a, Eq b,
      Eq c) => (a -> Bool) ->
                 Term b (Nat, a) ->
                   c -> ([(c, [Term b (Nat, a)])], Bool) ->
                          Maybe ([(c, [Term b (Nat, a)])], Bool);
insert_rx inf_sort t x rxb =
  (case rxb of {
    (rx, b) ->
      (case map_of rx x of {
        Nothing -> Just ((x, [t]) : rx, b);
        Just ts ->
          (case those (map (conflicts t) ts) of {
            Nothing -> Nothing;
            Just cs ->
              (if membera cs [] then Just rxb
                else Just (update x (t : ts) rx,
                            b || any (\ y -> inf_sort (snd y)) (concat cs)));
          });
      });
  });

decomp_impl ::
  forall a b c.
    (Eq a, Eq b,
      Eq c) => (a -> Bool) ->
                 [(Term b (Nat, a), Term b c)] ->
                   Maybe ([((Nat, a), Term b c)],
                           ([(c, [Term b (Nat, a)])], Bool));
decomp_impl inf_sort ((t, Var y) : mp) =
  (case decomp_impl inf_sort mp of {
    Nothing -> Nothing;
    Just (lx, rx) -> (case insert_rx inf_sort t y rx of {
                       Nothing -> Nothing;
                       Just rxa -> Just (lx, rxa);
                     });
  });
decomp_impl inf_sort ((Var x, Fun g ls) : mp) =
  (case decomp_impl inf_sort mp of {
    Nothing -> Nothing;
    Just (lx, rx) -> Just ((x, Fun g ls) : lx, rx);
  });
decomp_impl inf_sort ((Fun f ts, Fun g ls) : mp) =
  (if (f, size_list ts) == (g, size_list ls)
    then decomp_impl inf_sort (zip ts ls ++ mp) else Nothing);
decomp_impl inf_sort [] = Just ([], ([], False));

match_var_impl ::
  forall a b c.
    (Eq c) => ([((Nat, a), Term b c)], ([(c, [Term b (Nat, a)])], Bool)) ->
                ([((Nat, a), Term b c)], ([(c, [Term b (Nat, a)])], Bool));
match_var_impl mp =
  (case mp of {
    (xl, (rx, b)) ->
      let {
        xs = remdups (concatMap (vars_term_list . snd) xl);
      } in (xl, (filter (\ (x, ts) -> not (null (tl ts)) || membera xs x) rx,
                  b));
  });

match_steps_impl ::
  forall a b c.
    (Eq a, Eq b,
      Eq c) => (a -> Bool) ->
                 [(Term b (Nat, a), Term b c)] ->
                   Maybe ([((Nat, a), Term b c)],
                           ([(c, [Term b (Nat, a)])], Bool));
match_steps_impl inf_sort mp =
  map_option match_var_impl (decomp_impl inf_sort mp);

pat_inner_impl ::
  forall a b c.
    (Eq a, Eq b,
      Eq c) => (a -> Bool) ->
                 [[(Term b (Nat, a), Term b c)]] ->
                   [([((Nat, a), Term b c)],
                      ([(c, [Term b (Nat, a)])], Bool))] ->
                     Maybe [([((Nat, a), Term b c)],
                              ([(c, [Term b (Nat, a)])], Bool))];
pat_inner_impl inf_sort (mp : p) pd =
  (case match_steps_impl inf_sort mp of {
    Nothing -> pat_inner_impl inf_sort p pd;
    Just mpa ->
      (if empty_lr mpa then Nothing else pat_inner_impl inf_sort p (mpa : pd));
  });
pat_inner_impl inf_sort [] pd = Just pd;

subst_left ::
  forall a b c.
    ((Nat, a) -> Term b (Nat, a)) ->
      (Term b (Nat, a), Term b c) -> (Term b (Nat, a), Term b c);
subst_left tau = map_prod (\ t -> eval_term Fun t tau) id;

subst_match_problem_list ::
  forall a b c.
    ((Nat, a) -> Term b (Nat, a)) ->
      [(Term b (Nat, a), Term b c)] -> [(Term b (Nat, a), Term b c)];
subst_match_problem_list tau = map (subst_left tau);

subst_pat_problem_list ::
  forall a b c.
    ((Nat, a) -> Term b (Nat, a)) ->
      [[(Term b (Nat, a), Term b c)]] -> [[(Term b (Nat, a), Term b c)]];
subst_pat_problem_list tau = map (subst_match_problem_list tau);

mp_rx_list ::
  forall a b c.
    ([(a, [Term b (Nat, c)])], Bool) -> [(Term b (Nat, c), Term b a)];
mp_rx_list mp = concatMap (\ (x, a) -> map (\ t -> (t, Var x)) a) (fst mp);

mp_lr_list ::
  forall a b c.
    ([((Nat, a), Term b c)], ([(c, [Term b (Nat, a)])], Bool)) ->
      [(Term b (Nat, a), Term b c)];
mp_lr_list pair = (case pair of {
                    (lx, rx) -> map (map_prod Var id) lx ++ mp_rx_list rx;
                  });

pat_impl ::
  forall a b c.
    (Eq a, Eq b,
      Eq c) => (a -> [(b, [a])]) ->
                 (a -> Bool) ->
                   Nat ->
                     [[(Term b (Nat, a), Term b c)]] ->
                       Maybe [[[(Term b (Nat, a), Term b c)]]];
pat_impl cl inf_sort n p =
  (case pat_inner_impl inf_sort p [] of {
    Nothing -> Just [];
    Just pa ->
      (if all (\ mp -> snd (snd mp)) pa then Nothing
        else let {
               p_l = map mp_lr_list pa;
               x = find_var pa;
             } in Just (map (\ tau -> subst_pat_problem_list tau p_l)
                         (tau_s_list cl n x)));
  });

pats_impl ::
  forall a b c.
    (Eq a, Eq b,
      Eq c) => Nat ->
                 (a -> [(b, [a])]) ->
                   (a -> Bool) ->
                     Nat -> [[[(Term b (Nat, a), Term b c)]]] -> Bool;
pats_impl m cl inf_sort n ps =
  (case ps of {
    [] -> True;
    p : ps1 ->
      (case pat_impl cl inf_sort n p of {
        Nothing -> False;
        Just ps2 -> pats_impl m cl inf_sort (plus_nat n m) (ps2 ++ ps1);
      });
  });

pat_complete_impl ::
  forall a b c.
    (Eq a, Eq b,
      Eq c) => Nat ->
                 (a -> [(b, [a])]) ->
                   (a -> Bool) -> [[[(Term b (Nat, a), Term b c)]]] -> Bool;
pat_complete_impl m cl inf_sort ps =
  let {
    n = suc (max_list
              (concatMap ((map fst . vars_term_list) . fst)
                (concat (concat ps))));
  } in pats_impl m cl inf_sort n ps;

compute_inf_main :: forall a b. (Eq a) => Set a -> [(a, [(b, [a])])] -> Set a;
compute_inf_main m_inf ls =
  (case partition
          (\ (_, fs) ->
            all (all (\ tau -> not (member tau m_inf))) (map snd fs))
          ls
    of {
    (fin, lsa) ->
      (if null fin then m_inf
        else compute_inf_main (minus_set m_inf (Set (map fst fin))) lsa);
  });

compute_inf_sorts :: forall a b. (Eq b) => [((a, [b]), b)] -> Set b;
compute_inf_sorts cs =
  let {
    csa = map (\ tau ->
                (tau, map_filter
                        (\ x ->
                          (if snd x == tau then Just (fst x) else Nothing))
                        cs))
            (remdups (map snd cs));
  } in compute_inf_main (Set (map fst csa)) csa;

sorts_of_ssig_list :: forall a b. (Eq b) => [((a, [b]), b)] -> [b];
sorts_of_ssig_list cs =
  remdups (concatMap (\ (a, b) -> (case a of {
                                    (_, ss) -> (\ s -> s : ss);
                                  })
                                    b)
            cs);

decide_pat_complete ::
  forall a b c.
    (Eq a, Eq b,
      Eq c) => [((a, [b]), b)] -> [[[(Term a (Nat, b), Term a c)]]] -> Bool;
decide_pat_complete cs p =
  let {
    _ = sorts_of_ssig_list cs;
    m = max_list (map ((size_list . snd) . fst) cs);
    cl = (\ s ->
           map_filter
             (\ x ->
               (if ((\ a -> s == a) . snd) x then Just (fst x) else Nothing))
             cs);
    is = compute_inf_sorts cs;
  } in pat_complete_impl m cl (\ s -> member s is)
    p;

decide_pat_complete_lhss ::
  forall a b c.
    (Eq a, Eq b,
      Eq c) => [((a, [b]), b)] ->
                 [((a, [b]), b)] -> [Term a c] -> Sum (String -> String) Bool;
decide_pat_complete_lhss c d lhss =
  bind (check (distinct (map fst c))
         (showsl_lit "constructor information contains duplicate"))
    (\ _ ->
      bind (check (distinct (map fst d))
             (showsl_lit "defined symbol information contains duplicate"))
        (\ _ ->
          let {
            s = sorts_of_ssig_list c;
          } in bind (catch_error
                      (forallM
                        (\ (a, b) ->
                          (case a of {
                            (_, ss) ->
                              (\ _ ->
                                catch_error
                                  (forallM
                                    (\ sa ->
                                      check (membera s sa)
(showsl_lit
  "a defined symbol has argument sort that is not known in constructors"))
                                    ss)
                                  (\ x -> Inl (snd x)));
                          })
                            b)
                        d)
                      (\ x -> Inl (snd x)))
                 (\ _ ->
                   bind (case decide_nonempty_sorts s c of {
                          Nothing -> Inr ();
                          Just _ -> Inl (showsl_lit "some sort is empty");
                        })
                     (\ _ ->
                       let {
                         pats =
                           map (\ (a, b) ->
                                 (case a of {
                                   (f, ss) ->
                                     (\ _ ->
                                       Fun f
 (map Var (zip (upt zero_nat (size_list ss)) ss)));
                                 })
                                   b)
                             d;
                         p = map (\ pat -> map (\ lhs -> [(pat, lhs)]) lhss)
                               pats;
                       } in Inr (decide_pat_complete c p)))));

pat_complete_alg ::
  forall a b c.
    (Eq a, Eq b,
      Eq c) => [((a, [b]), b)] -> [((a, [b]), b)] -> [Term a c] -> Bool;
pat_complete_alg c d lhss =
  (case decide_pat_complete_lhss c d lhss of {
    Inl err ->
      (error :: forall a. String -> (() -> a) -> a) (err "") (\ _ -> True);
    Inr res -> res;
  });

createHaskellInput :: Integer -> Integer -> [([Integer], [Integer])] -> String;
createHaskellInput c n perms =
  (case test_problem_integer c n perms of {
    (_, (_, lhss)) ->
      "module Test(g) where\n\ndata B = TT | FF\n\n" ++
        foldr (\ l -> (\ a -> (term_to_haskell l ++ " = TT\n") ++ a)) lhss "";
  });

pat_complete_alg_test :: Integer -> Integer -> [([Integer], [Integer])] -> Bool;
pat_complete_alg_test c n perms = (case test_problem_integer c n perms of {
                                    (ca, (a, b)) -> pat_complete_alg ca a b;
                                  });

show_pat_complete_test ::
  Integer -> Integer -> [([Integer], [Integer])] -> String;
show_pat_complete_test c n perms =
  (case test_problem_integer c n perms of {
    (_, (_, lhss)) -> showsl_lines "empty" lhss "";
  });

patCompleteAutomataTest ::
  forall a b c d.
    (String -> a) ->
      (String -> Integer -> b) ->
        (b -> [a] -> a -> c) ->
          ([b] -> [a] -> [a] -> [c] -> d) ->
            (d -> d -> Bool) ->
              Integer -> Integer -> [([Integer], [Integer])] -> Bool;
patCompleteAutomataTest cState cSym cRule cAut checkSubset c n perms =
  checkSubset (automataLeft cState cSym cRule cAut n)
    (automataRight cState cSym cRule cAut c n perms);

}
