#/bin/bash
RESULT_DIR=../results
# select correct architecture
ARCH=amd64-darwin  # MacOS
# ARCH=amd64-linux   # Linux
HEAPFILE=pat-test.${ARCH}
MAX_N=100

mkdir -p ${RESULT_DIR}

echo "compiling sources"
(cd src-agcp-v0.02/src/pat_complete_tests; make)
if cp src-agcp-v0.02/src/pat_complete_tests/${HEAPFILE} .;
then 
  mkdir -p ${RESULT_DIR}
  echo "-----------------------------"
  echo "Testing our decision procedure via SML compiler"
  sml @SMLload=${HEAPFILE} our ${MAX_N} | tee ${RESULT_DIR}/results_OUR_sml.txt
  echo "-----------------------------"
  echo "Testing complement algorithm via AGCP"
  sml @SMLload=${HEAPFILE} complement ${MAX_N} | tee ${RESULT_DIR}/results_COMP_sml.txt
else
  echo "please adjust ARCH in execute_tests.sh, look for suffix of "; 
  ls src-agcp-v0.02/src/pat_complete_tests/pat-test.*;
fi
