(******************************************************************************
 * file: rwtools/commands/io_spec.yacc
 * description: reading spec file
 * author: AOTO Takahito
 * 
 ******************************************************************************)

signature IO_SPEC =  
  sig
      val rdFile: string 
		  -> 
             Term.decl list                 (* FUNCTIONS section *)
             * (Term.term * Term.term) list   (* RULES section *)
             * (Term.term * Term.term) list   (* EQUATIONS section *)
             * (Term.term * Term.term) list   (* CONJECTURES section *)
             * (int * Term.fun_key * Order.rpo_status * int list) list
                               (* PRECEDENCE section *)
             * (Fun.ord_key * Poly.poly) list (* POLYNOMIALS section *)
             * (int * ((int * int * Term.fun_key * int list) list))
                               (* KBOSPECIFICATION section *)
                               (* varweight + [prec, weight, f, lex] *)
  end;


structure IOSpec : IO_SPEC =  
  struct
  
  (* ʸ:  *)
  structure SpecLrVals = SpecLrValsFun (structure Token = LrParser.Token);
  structure SpecLex = SpecLexFun (structure Tokens = SpecLrVals.Tokens);
  structure SpecParser = Join (structure ParserData = SpecLrVals.ParserData;
                               structure Lex = SpecLex;
			       structure LrParser = LrParser);

  (* ʸϤؿ: ȥ꡼ࢪʸ *)
  fun parserStream istream = 
      let val lexer = SpecParser.makeLexer 
			  (fn n=>TextIO.inputN (istream, n));
	  val print_error = fn (s, i, _) => 
			       print (s^", line " ^ Int.toString(i) ^ "\n");
      in #1 (SpecParser.parse (0, lexer, print_error, ()))
      end;

  (* ʸϤؿ: ե̾ʸ *)
  fun rdFile filename = parserStream (TextIO.openIn filename)
			
  end;




