functor SpecLrValsFun(structure Token : TOKEN)
 : sig structure ParserData : PARSER_DATA
       structure Tokens : Spec_TOKENS
   end
 = 
struct
structure ParserData=
struct
structure Header = 
struct
(******************************************************************************
 * file: rwtools/commands/spec.yacc
 * description: parser for specification file of provers
 * author: AOTO Takahito
 * 
 ******************************************************************************)

type yaccexpr = (* Sort.sort list                   SORTS section  *)
                	Term.decl list                 (* FUNCTIONS section *)
	                * (Term.term * Term.term) list   (* RULES section *)
	                * (Term.term * Term.term) list   (* EQUATIONS section *)
	                * (Term.term * Term.term) list   (* CONJECTURES section *)
	                * (int * Term.fun_key * Order.rpo_status * int list) list
	                                                 (* PRECEDENCE section *)
	                * (Term.fun_key * Poly.poly) list (* POLYNOMIALS section *)
	                * (int * ((int * int * Term.fun_key * int list) list))
	                                                 (* KBOSPECIFICATION section *)
	                                                 (* varweight + [prec, weight, f, lex] *)
fun mkDecl tupdecl = 
       map (fn x => {sym = #1 x,sort= #2 x}:Term.decl) 
            (tupdecl: (Atom.atom * Sort.sort) list)
fun mkProc [] id = Sort.fromString id
  | mkProc xs id = Sort.Proc (xs, Sort.fromString id)

fun decreasePrec (i,f,st,ns) = (i-1,f,st,ns)
fun increasePrec xs = let val len = List.length xs
                      in List.map (fn (i,f,st,ns) => (i+len,f,st,ns)) xs
                      end

fun decreaseKboPrec (t,i,f,j,ns) = if t then (t,i,f,j,ns) else (t,i-1,f,j,ns)

exception SpecError;

fun mkKboPrec xs =  let fun divide [] (ys,zs) = (ys,zs)
                          | divide ((t,i,f,opj,ns)::us) (ys,zs) = 
                               if isSome opj 
	                       then if t andalso (null ys) 
	                            then divide us ([valOf opj],zs)
	                            else divide us (ys, (i,valOf opj,f,ns)::zs)
                               else (print "non-integer weight\n"; raise SpecError)
                        val (ys,zs) = divide xs ([],[])
                        val vw = if null ys  then 1 else (hd ys)
                        val len = List.length zs
	           in (vw, List.map (fn (i,j,f,ns) => (i+len,j,f,ns)) zs)
                   end

exception VarError;

datatype pexp = Plus of mexp list
     and mexp  = Times of aexp list
     and aexp  = Int  of int | Vari of string | Poly of pexp

fun toAexp x = case Int.fromString x 
		    of SOME n => Int  n  
		     | NONE   => Vari x

fun varNum vs name = 
  let fun varNumSub [] _ = raise VarError
        | varNumSub (v::ss) count = if v = name then count else varNumSub ss (count+1)
  in  varNumSub vs 1
  end 

fun aexpToPoly _  (Int n) = IntListMap2.singleton ([],n)
  | aexpToPoly vs (Vari s) = IntListMap2.singleton ([varNum vs s],1)
  | aexpToPoly vs  (Poly p) = pexpToPoly vs p

and mexpToPoly vs (Times es) = 
       List.foldl (fn (p,q) => Poly.times (p,q)) 
                  (IntListMap2.singleton ([],1))
                  (List.map (aexpToPoly vs) es)

and pexpToPoly vs (Plus es) = 
       List.foldl (fn (p,q) => Poly.plus (p,q)) 
                  (IntListMap2.singleton ([],0))
                  (List.map (mexpToPoly vs) es)

val toPoly = pexpToPoly


(* 桼 *)

end
structure LrTable = Token.LrTable
structure Token = Token
local open LrTable in 
val table=let val actionRows =
"\
\\001\000\001\000\017\000\008\000\043\000\013\000\016\000\000\000\
\\001\000\001\000\017\000\013\000\016\000\000\000\
\\001\000\001\000\027\000\000\000\
\\001\000\001\000\053\000\000\000\
\\001\000\001\000\056\000\000\000\
\\001\000\001\000\057\000\000\000\
\\001\000\001\000\072\000\000\000\
\\001\000\001\000\075\000\000\000\
\\001\000\001\000\078\000\000\000\
\\001\000\001\000\087\000\000\000\
\\001\000\001\000\092\000\012\000\091\000\000\000\
\\001\000\001\000\099\000\007\000\098\000\000\000\
\\001\000\001\000\104\000\000\000\
\\001\000\001\000\105\000\000\000\
\\001\000\002\000\140\000\004\000\142\000\005\000\142\000\015\000\140\000\
\\016\000\140\000\017\000\140\000\018\000\140\000\019\000\140\000\
\\020\000\140\000\021\000\140\000\000\000\
\\001\000\002\000\071\000\000\000\
\\001\000\003\000\019\000\000\000\
\\001\000\003\000\079\000\000\000\
\\001\000\003\000\093\000\000\000\
\\001\000\004\000\025\000\000\000\
\\001\000\004\000\045\000\005\000\044\000\000\000\
\\001\000\007\000\089\000\010\000\088\000\000\000\
\\001\000\008\000\055\000\009\000\054\000\000\000\
\\001\000\008\000\086\000\000\000\
\\001\000\008\000\109\000\000\000\
\\001\000\008\000\115\000\000\000\
\\001\000\009\000\103\000\012\000\102\000\000\000\
\\001\000\010\000\037\000\000\000\
\\001\000\010\000\116\000\000\000\
\\001\000\012\000\081\000\000\000\
\\001\000\021\000\000\000\000\000\
\\120\000\000\000\
\\121\000\000\000\
\\122\000\014\000\004\000\000\000\
\\123\000\000\000\
\\124\000\015\000\006\000\000\000\
\\125\000\000\000\
\\126\000\016\000\011\000\000\000\
\\127\000\000\000\
\\128\000\017\000\021\000\000\000\
\\129\000\000\000\
\\130\000\018\000\034\000\000\000\
\\131\000\000\000\
\\132\000\019\000\047\000\000\000\
\\133\000\000\000\
\\134\000\020\000\059\000\000\000\
\\135\000\000\000\
\\136\000\002\000\018\000\000\000\
\\137\000\001\000\009\000\000\000\
\\138\000\000\000\
\\139\000\000\000\
\\141\000\000\000\
\\143\000\001\000\032\000\000\000\
\\144\000\000\000\
\\145\000\002\000\026\000\000\000\
\\146\000\001\000\017\000\013\000\016\000\000\000\
\\147\000\000\000\
\\148\000\000\000\
\\149\000\000\000\
\\150\000\007\000\028\000\000\000\
\\151\000\000\000\
\\152\000\000\000\
\\153\000\000\000\
\\154\000\000\000\
\\155\000\003\000\040\000\000\000\
\\156\000\000\000\
\\157\000\002\000\036\000\000\000\
\\158\000\001\000\017\000\013\000\016\000\000\000\
\\159\000\000\000\
\\160\000\000\000\
\\161\000\000\000\
\\162\000\002\000\064\000\009\000\063\000\000\000\
\\163\000\001\000\050\000\000\000\
\\164\000\000\000\
\\165\000\003\000\065\000\000\000\
\\166\000\000\000\
\\167\000\011\000\083\000\000\000\
\\168\000\000\000\
\\169\000\000\000\
\\170\000\000\000\
\\171\000\000\000\
\\172\000\011\000\062\000\000\000\
\\173\000\000\000\
\\174\000\000\000\
\\175\000\000\000\
\\176\000\009\000\110\000\000\000\
\\177\000\001\000\101\000\000\000\
\\178\000\000\000\
\\179\000\006\000\107\000\000\000\
\\180\000\000\000\
\\181\000\005\000\106\000\000\000\
\\182\000\000\000\
\\183\000\000\000\
\\184\000\000\000\
\\185\000\000\000\
\\186\000\002\000\077\000\009\000\076\000\000\000\
\\187\000\001\000\070\000\007\000\069\000\000\000\
\\188\000\000\000\
\\189\000\003\000\094\000\000\000\
\\190\000\000\000\
\"
val actionRowNumbers =
"\033\000\035\000\048\000\037\000\
\\055\000\047\000\032\000\016\000\
\\039\000\067\000\060\000\019\000\
\\054\000\034\000\002\000\059\000\
\\048\000\052\000\041\000\067\000\
\\066\000\036\000\027\000\001\000\
\\055\000\064\000\000\000\046\000\
\\020\000\049\000\014\000\043\000\
\\072\000\038\000\067\000\001\000\
\\056\000\053\000\003\000\022\000\
\\062\000\058\000\004\000\005\000\
\\045\000\081\000\071\000\040\000\
\\074\000\065\000\068\000\063\000\
\\001\000\057\000\051\000\050\000\
\\031\000\096\000\015\000\042\000\
\\006\000\072\000\072\000\007\000\
\\061\000\095\000\044\000\008\000\
\\017\000\081\000\029\000\070\000\
\\069\000\076\000\096\000\096\000\
\\023\000\009\000\080\000\021\000\
\\073\000\010\000\094\000\093\000\
\\018\000\098\000\011\000\086\000\
\\075\000\079\000\026\000\012\000\
\\013\000\090\000\088\000\083\000\
\\011\000\091\000\024\000\085\000\
\\078\000\010\000\099\000\076\000\
\\011\000\011\000\025\000\028\000\
\\086\000\077\000\097\000\089\000\
\\087\000\092\000\011\000\084\000\
\\082\000\030\000"
val gotoT =
"\
\\001\000\117\000\002\000\001\000\000\000\
\\003\000\003\000\000\000\
\\010\000\006\000\011\000\005\000\000\000\
\\004\000\008\000\000\000\
\\014\000\013\000\015\000\012\000\016\000\011\000\020\000\010\000\000\000\
\\000\000\
\\000\000\
\\000\000\
\\005\000\018\000\000\000\
\\016\000\022\000\018\000\021\000\019\000\020\000\020\000\010\000\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\010\000\027\000\011\000\005\000\000\000\
\\012\000\029\000\013\000\028\000\000\000\
\\006\000\031\000\000\000\
\\016\000\022\000\018\000\033\000\019\000\020\000\020\000\010\000\000\000\
\\000\000\
\\000\000\
\\000\000\
\\016\000\036\000\020\000\010\000\000\000\
\\014\000\037\000\015\000\012\000\016\000\011\000\020\000\010\000\000\000\
\\000\000\
\\016\000\040\000\017\000\039\000\020\000\010\000\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\007\000\044\000\000\000\
\\021\000\047\000\022\000\046\000\000\000\
\\000\000\
\\016\000\022\000\018\000\049\000\019\000\020\000\020\000\010\000\000\000\
\\016\000\050\000\020\000\010\000\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\008\000\056\000\000\000\
\\025\000\059\000\026\000\058\000\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\016\000\064\000\020\000\010\000\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\033\000\066\000\034\000\065\000\000\000\
\\000\000\
\\000\000\
\\000\000\
\\021\000\071\000\022\000\046\000\000\000\
\\021\000\072\000\022\000\046\000\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\025\000\078\000\026\000\058\000\000\000\
\\000\000\
\\000\000\
\\000\000\
\\023\000\080\000\000\000\
\\033\000\082\000\034\000\065\000\000\000\
\\033\000\083\000\034\000\065\000\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\024\000\088\000\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\028\000\095\000\030\000\094\000\031\000\093\000\000\000\
\\027\000\098\000\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\028\000\106\000\030\000\094\000\031\000\093\000\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\024\000\109\000\000\000\
\\000\000\
\\023\000\110\000\000\000\
\\030\000\111\000\031\000\093\000\000\000\
\\028\000\112\000\030\000\094\000\031\000\093\000\000\000\
\\000\000\
\\000\000\
\\027\000\115\000\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\028\000\116\000\030\000\094\000\031\000\093\000\000\000\
\\000\000\
\\000\000\
\\000\000\
\"
val numstates = 118
val numrules = 71
val s = ref "" and index = ref 0
val string_to_int = fn () => 
let val i = !index
in index := i+2; Char.ord(String.sub(!s,i)) + Char.ord(String.sub(!s,i+1)) * 256
end
val string_to_list = fn s' =>
    let val len = String.size s'
        fun f () =
           if !index < len then string_to_int() :: f()
           else nil
   in index := 0; s := s'; f ()
   end
val string_to_pairlist = fn (conv_key,conv_entry) =>
     let fun f () =
         case string_to_int()
         of 0 => EMPTY
          | n => PAIR(conv_key (n-1),conv_entry (string_to_int()),f())
     in f
     end
val string_to_pairlist_default = fn (conv_key,conv_entry) =>
    let val conv_row = string_to_pairlist(conv_key,conv_entry)
    in fn () =>
       let val default = conv_entry(string_to_int())
           val row = conv_row()
       in (row,default)
       end
   end
val string_to_table = fn (convert_row,s') =>
    let val len = String.size s'
        fun f ()=
           if !index < len then convert_row() :: f()
           else nil
     in (s := s'; index := 0; f ())
     end
local
  val memo = Array.array(numstates+numrules,ERROR)
  val _ =let fun g i=(Array.update(memo,i,REDUCE(i-numstates)); g(i+1))
       fun f i =
            if i=numstates then g i
            else (Array.update(memo,i,SHIFT (STATE i)); f (i+1))
          in f 0 handle General.Subscript => ()
          end
in
val entry_to_action = fn 0 => ACCEPT | 1 => ERROR | j => Array.sub(memo,(j-2))
end
val gotoT=Array.fromList(string_to_table(string_to_pairlist(NT,STATE),gotoT))
val actionRows=string_to_table(string_to_pairlist_default(T,entry_to_action),actionRows)
val actionRowNumbers = string_to_list actionRowNumbers
val actionT = let val actionRowLookUp=
let val a=Array.fromList(actionRows) in fn i=>Array.sub(a,i) end
in Array.fromList(List.map actionRowLookUp actionRowNumbers)
end
in LrTable.mkLrTable {actions=actionT,gotos=gotoT,numRules=numrules,
numStates=numstates,initialState=STATE 0}
end
end
local open Header in
type pos = int
type arg = unit
structure MlyValue = 
struct
datatype svalue = VOID | ntVOID of unit ->  unit
 | ID of unit ->  (string)
 | KBOPREC of unit ->  (bool*int*Term.fun_key*int option*int list)
 | KBOPRECLIST of unit ->  ( ( bool * int * Term.fun_key * int option * int list )  list)
 | COEFFICIENT of unit ->  (int) | AEXP of unit ->  (aexp)
 | AEXPLIST of unit ->  (aexp list) | MONO of unit ->  (mexp)
 | MONOLIST of unit ->  (mexp list)
 | VARLIST of unit ->  (string list)
 | FUN_POLY of unit ->  ( ( Term.fun_key * int IntListMap2.map ) )
 | POLYLIST of unit ->  ( ( Term.fun_key * int IntListMap2.map )  list)
 | NUMLIST of unit ->  (int list) | EX of unit ->  (int list)
 | PREC of unit ->  (int*Term.fun_key*Order.rpo_status*int list)
 | PRECLIST of unit ->  ( ( int * Term.fun_key * Order.rpo_status * int list )  list)
 | VAR of unit ->  ( ( Atom.atom * int ) *Sort.sort)
 | EQUA of unit ->  (Term.term*Term.term)
 | EQUALIST of unit ->  ( ( Term.term * Term.term )  list)
 | TERMLIST of unit ->  (Term.term list)
 | TERM of unit ->  (Term.term)
 | RULE of unit ->  (Term.term*Term.term)
 | RULELIST of unit ->  ( ( Term.term * Term.term )  list)
 | SORTARGS of unit ->  (Sort.sort list)
 | PROCTYPE of unit ->  (Sort.sort)
 | FUNC of unit ->  (Atom.atom*Sort.sort)
 | FUNCLIST of unit ->  ( ( Atom.atom * Sort.sort )  list)
 | SORTLIST of unit ->  (Sort.sort list)
 | KboPART of unit ->  (int* ( (int * int * Term.fun_key * int list) list ) )
 | PolyPART of unit ->  ( ( Term.fun_key * Poly.poly )  list)
 | PrecPART of unit ->  ( ( int * Term.fun_key * Order.rpo_status * int list )  list)
 | ConjPART of unit ->  ( ( Term.term * Term.term )  list)
 | EquaPART of unit ->  ( ( Term.term * Term.term )  list)
 | RulePART of unit ->  ( ( Term.term * Term.term )  list)
 | FuncPART of unit ->  (Term.decl list)
 | START of unit ->  (yaccexpr)
end
type svalue = MlyValue.svalue
type result = yaccexpr
end
structure EC=
struct
open LrTable
infix 5 $$
fun x $$ y = y::x
val is_keyword =
fn _ => false
val preferred_change : (term list * term list) list = 
nil
val noShift = 
fn (T 20) => true | _ => false
val showTerminal =
fn (T 0) => "ID"
  | (T 1) => "SEMICOLON"
  | (T 2) => "COLON"
  | (T 3) => "THINARROW"
  | (T 4) => "TIMES"
  | (T 5) => "PLUS"
  | (T 6) => "LPAREN"
  | (T 7) => "RPAREN"
  | (T 8) => "COM"
  | (T 9) => "EQ"
  | (T 10) => "LBRACKET"
  | (T 11) => "RBRACKET"
  | (T 12) => "QUESTION"
  | (T 13) => "SORTS"
  | (T 14) => "RULES"
  | (T 15) => "EQUATIONS"
  | (T 16) => "CONJECTURES"
  | (T 17) => "PRECEDENCE"
  | (T 18) => "POLYNOMIALS"
  | (T 19) => "KBOSPECIFICATION"
  | (T 20) => "EOF"
  | _ => "bogus-term"
local open Header in
val errtermvalue=
fn _ => MlyValue.VOID
end
val terms : term list = nil
 $$ (T 20) $$ (T 19) $$ (T 18) $$ (T 17) $$ (T 16) $$ (T 15) $$ (T 14)
 $$ (T 13) $$ (T 12) $$ (T 11) $$ (T 10) $$ (T 9) $$ (T 8) $$ (T 7)
 $$ (T 6) $$ (T 5) $$ (T 4) $$ (T 3) $$ (T 2) $$ (T 1)end
structure Actions =
struct 
exception mlyAction of int
local open Header in
val actions = 
fn (i392,defaultPos,stack,
    (()):arg) =>
case (i392,stack)
of  ( 0, ( ( _, ( MlyValue.KboPART KboPART1, _, KboPART1right)) :: ( _
, ( MlyValue.PolyPART PolyPART1, _, _)) :: ( _, ( MlyValue.PrecPART 
PrecPART1, _, _)) :: ( _, ( MlyValue.ConjPART ConjPART1, _, _)) :: ( _
, ( MlyValue.EquaPART EquaPART1, _, _)) :: ( _, ( MlyValue.RulePART 
RulePART1, _, _)) :: ( _, ( MlyValue.FuncPART FuncPART1, FuncPART1left
, _)) :: rest671)) => let val  result = MlyValue.START (fn _ => let
 val  (FuncPART as FuncPART1) = FuncPART1 ()
 val  (RulePART as RulePART1) = RulePART1 ()
 val  (EquaPART as EquaPART1) = EquaPART1 ()
 val  (ConjPART as ConjPART1) = ConjPART1 ()
 val  (PrecPART as PrecPART1) = PrecPART1 ()
 val  (PolyPART as PolyPART1) = PolyPART1 ()
 val  (KboPART as KboPART1) = KboPART1 ()
 in ((FuncPART,RulePART,EquaPART,ConjPART,PrecPART,PolyPART,KboPART))

end)
 in ( LrTable.NT 0, ( result, FuncPART1left, KboPART1right), rest671)

end
|  ( 1, ( ( _, ( MlyValue.FUNCLIST FUNCLIST1, _, FUNCLIST1right)) :: (
 _, ( _, SORTS1left, _)) :: rest671)) => let val  result = 
MlyValue.FuncPART (fn _ => let val  (FUNCLIST as FUNCLIST1) = 
FUNCLIST1 ()
 in (mkDecl FUNCLIST)
end)
 in ( LrTable.NT 1, ( result, SORTS1left, FUNCLIST1right), rest671)

end
|  ( 2, ( rest671)) => let val  result = MlyValue.FuncPART (fn _ => (
[]))
 in ( LrTable.NT 1, ( result, defaultPos, defaultPos), rest671)
end
|  ( 3, ( ( _, ( MlyValue.RULELIST RULELIST1, _, RULELIST1right)) :: (
 _, ( _, RULES1left, _)) :: rest671)) => let val  result = 
MlyValue.RulePART (fn _ => let val  (RULELIST as RULELIST1) = 
RULELIST1 ()
 in (RULELIST)
end)
 in ( LrTable.NT 2, ( result, RULES1left, RULELIST1right), rest671)

end
|  ( 4, ( rest671)) => let val  result = MlyValue.RulePART (fn _ => (
[]))
 in ( LrTable.NT 2, ( result, defaultPos, defaultPos), rest671)
end
|  ( 5, ( ( _, ( MlyValue.EQUALIST EQUALIST1, _, EQUALIST1right)) :: (
 _, ( _, EQUATIONS1left, _)) :: rest671)) => let val  result = 
MlyValue.EquaPART (fn _ => let val  (EQUALIST as EQUALIST1) = 
EQUALIST1 ()
 in (EQUALIST)
end)
 in ( LrTable.NT 3, ( result, EQUATIONS1left, EQUALIST1right), rest671
)
end
|  ( 6, ( rest671)) => let val  result = MlyValue.EquaPART (fn _ => (
[]))
 in ( LrTable.NT 3, ( result, defaultPos, defaultPos), rest671)
end
|  ( 7, ( ( _, ( MlyValue.EQUALIST EQUALIST1, _, EQUALIST1right)) :: (
 _, ( _, CONJECTURES1left, _)) :: rest671)) => let val  result = 
MlyValue.ConjPART (fn _ => let val  (EQUALIST as EQUALIST1) = 
EQUALIST1 ()
 in (EQUALIST)
end)
 in ( LrTable.NT 4, ( result, CONJECTURES1left, EQUALIST1right), 
rest671)
end
|  ( 8, ( rest671)) => let val  result = MlyValue.ConjPART (fn _ => (
[]))
 in ( LrTable.NT 4, ( result, defaultPos, defaultPos), rest671)
end
|  ( 9, ( ( _, ( MlyValue.PRECLIST PRECLIST1, _, PRECLIST1right)) :: (
 _, ( _, PRECEDENCE1left, _)) :: rest671)) => let val  result = 
MlyValue.PrecPART (fn _ => let val  (PRECLIST as PRECLIST1) = 
PRECLIST1 ()
 in (increasePrec PRECLIST)
end)
 in ( LrTable.NT 5, ( result, PRECEDENCE1left, PRECLIST1right), 
rest671)
end
|  ( 10, ( rest671)) => let val  result = MlyValue.PrecPART (fn _ => (
[]))
 in ( LrTable.NT 5, ( result, defaultPos, defaultPos), rest671)
end
|  ( 11, ( ( _, ( MlyValue.POLYLIST POLYLIST1, _, POLYLIST1right)) :: 
( _, ( _, POLYNOMIALS1left, _)) :: rest671)) => let val  result = 
MlyValue.PolyPART (fn _ => let val  (POLYLIST as POLYLIST1) = 
POLYLIST1 ()
 in (POLYLIST)
end)
 in ( LrTable.NT 6, ( result, POLYNOMIALS1left, POLYLIST1right), 
rest671)
end
|  ( 12, ( rest671)) => let val  result = MlyValue.PolyPART (fn _ => (
[]))
 in ( LrTable.NT 6, ( result, defaultPos, defaultPos), rest671)
end
|  ( 13, ( ( _, ( MlyValue.KBOPRECLIST KBOPRECLIST1, _, 
KBOPRECLIST1right)) :: ( _, ( _, KBOSPECIFICATION1left, _)) :: rest671
)) => let val  result = MlyValue.KboPART (fn _ => let val  (
KBOPRECLIST as KBOPRECLIST1) = KBOPRECLIST1 ()
 in (mkKboPrec KBOPRECLIST)
end)
 in ( LrTable.NT 7, ( result, KBOSPECIFICATION1left, KBOPRECLIST1right
), rest671)
end
|  ( 14, ( rest671)) => let val  result = MlyValue.KboPART (fn _ => (
(0,[])))
 in ( LrTable.NT 7, ( result, defaultPos, defaultPos), rest671)
end
|  ( 15, ( ( _, ( MlyValue.FUNCLIST FUNCLIST1, _, FUNCLIST1right)) ::
 _ :: ( _, ( MlyValue.FUNC FUNC1, FUNC1left, _)) :: rest671)) => let
 val  result = MlyValue.FUNCLIST (fn _ => let val  (FUNC as FUNC1) = 
FUNC1 ()
 val  (FUNCLIST as FUNCLIST1) = FUNCLIST1 ()
 in (FUNC::FUNCLIST)
end)
 in ( LrTable.NT 9, ( result, FUNC1left, FUNCLIST1right), rest671)
end
|  ( 16, ( ( _, ( MlyValue.FUNC FUNC1, FUNC1left, FUNC1right)) :: 
rest671)) => let val  result = MlyValue.FUNCLIST (fn _ => let val  (
FUNC as FUNC1) = FUNC1 ()
 in ([FUNC])
end)
 in ( LrTable.NT 9, ( result, FUNC1left, FUNC1right), rest671)
end
|  ( 17, ( rest671)) => let val  result = MlyValue.FUNCLIST (fn _ => (
[]))
 in ( LrTable.NT 9, ( result, defaultPos, defaultPos), rest671)
end
|  ( 18, ( ( _, ( MlyValue.PROCTYPE PROCTYPE1, _, PROCTYPE1right)) ::
 _ :: ( _, ( MlyValue.ID ID1, ID1left, _)) :: rest671)) => let val  
result = MlyValue.FUNC (fn _ => let val  (ID as ID1) = ID1 ()
 val  (PROCTYPE as PROCTYPE1) = PROCTYPE1 ()
 in ((Fun.fromString ID,PROCTYPE))
end)
 in ( LrTable.NT 10, ( result, ID1left, PROCTYPE1right), rest671)
end
|  ( 19, ( ( _, ( MlyValue.ID ID1, _, ID1right)) :: _ :: ( _, ( 
MlyValue.SORTARGS SORTARGS1, SORTARGS1left, _)) :: rest671)) => let
 val  result = MlyValue.PROCTYPE (fn _ => let val  (SORTARGS as 
SORTARGS1) = SORTARGS1 ()
 val  (ID as ID1) = ID1 ()
 in (Sort.Proc (SORTARGS, Sort.fromString ID))
end)
 in ( LrTable.NT 11, ( result, SORTARGS1left, ID1right), rest671)
end
|  ( 20, ( ( _, ( MlyValue.ID ID1, ID1left, ID1right)) :: rest671)) =>
 let val  result = MlyValue.PROCTYPE (fn _ => let val  (ID as ID1) = 
ID1 ()
 in (Sort.fromString ID)
end)
 in ( LrTable.NT 11, ( result, ID1left, ID1right), rest671)
end
|  ( 21, ( ( _, ( MlyValue.ID ID1, _, ID1right)) :: _ :: ( _, ( 
MlyValue.SORTARGS SORTARGS1, SORTARGS1left, _)) :: rest671)) => let
 val  result = MlyValue.SORTARGS (fn _ => let val  (SORTARGS as 
SORTARGS1) = SORTARGS1 ()
 val  (ID as ID1) = ID1 ()
 in (SORTARGS@[Sort.fromString ID])
end)
 in ( LrTable.NT 12, ( result, SORTARGS1left, ID1right), rest671)
end
|  ( 22, ( ( _, ( MlyValue.ID ID1, ID1left, ID1right)) :: rest671)) =>
 let val  result = MlyValue.SORTARGS (fn _ => let val  (ID as ID1) = 
ID1 ()
 in ([Sort.fromString ID])
end)
 in ( LrTable.NT 12, ( result, ID1left, ID1right), rest671)
end
|  ( 23, ( rest671)) => let val  result = MlyValue.SORTARGS (fn _ => (
[]))
 in ( LrTable.NT 12, ( result, defaultPos, defaultPos), rest671)
end
|  ( 24, ( ( _, ( MlyValue.RULELIST RULELIST1, _, RULELIST1right)) ::
 _ :: ( _, ( MlyValue.RULE RULE1, RULE1left, _)) :: rest671)) => let
 val  result = MlyValue.RULELIST (fn _ => let val  (RULE as RULE1) = 
RULE1 ()
 val  (RULELIST as RULELIST1) = RULELIST1 ()
 in (RULE::RULELIST)
end)
 in ( LrTable.NT 13, ( result, RULE1left, RULELIST1right), rest671)

end
|  ( 25, ( ( _, ( MlyValue.RULE RULE1, RULE1left, RULE1right)) :: 
rest671)) => let val  result = MlyValue.RULELIST (fn _ => let val  (
RULE as RULE1) = RULE1 ()
 in ([RULE])
end)
 in ( LrTable.NT 13, ( result, RULE1left, RULE1right), rest671)
end
|  ( 26, ( rest671)) => let val  result = MlyValue.RULELIST (fn _ => (
[]))
 in ( LrTable.NT 13, ( result, defaultPos, defaultPos), rest671)
end
|  ( 27, ( ( _, ( MlyValue.TERM TERM2, _, TERM2right)) :: _ :: ( _, ( 
MlyValue.TERM TERM1, TERM1left, _)) :: rest671)) => let val  result = 
MlyValue.RULE (fn _ => let val  TERM1 = TERM1 ()
 val  TERM2 = TERM2 ()
 in ((TERM1,TERM2))
end)
 in ( LrTable.NT 14, ( result, TERM1left, TERM2right), rest671)
end
|  ( 28, ( ( _, ( _, _, RPAREN1right)) :: ( _, ( MlyValue.TERMLIST 
TERMLIST1, _, _)) :: _ :: ( _, ( MlyValue.ID ID1, ID1left, _)) :: 
rest671)) => let val  result = MlyValue.TERM (fn _ => let val  (ID as 
ID1) = ID1 ()
 val  (TERMLIST as TERMLIST1) = TERMLIST1 ()
 in (Term.Fun (Fun.fromString ID,TERMLIST,Sort.null))
end)
 in ( LrTable.NT 15, ( result, ID1left, RPAREN1right), rest671)
end
|  ( 29, ( ( _, ( _, _, RPAREN1right)) :: _ :: ( _, ( MlyValue.ID ID1,
 ID1left, _)) :: rest671)) => let val  result = MlyValue.TERM (fn _ =>
 let val  (ID as ID1) = ID1 ()
 in (Term.Fun (Fun.fromString ID,[],Sort.null))
end)
 in ( LrTable.NT 15, ( result, ID1left, RPAREN1right), rest671)
end
|  ( 30, ( ( _, ( MlyValue.ID ID1, ID1left, ID1right)) :: rest671)) =>
 let val  result = MlyValue.TERM (fn _ => let val  (ID as ID1) = ID1
 ()
 in (Term.Fun (Fun.fromString ID,[],Sort.null))
end)
 in ( LrTable.NT 15, ( result, ID1left, ID1right), rest671)
end
|  ( 31, ( ( _, ( MlyValue.VAR VAR1, VAR1left, VAR1right)) :: rest671)
) => let val  result = MlyValue.TERM (fn _ => let val  (VAR as VAR1) =
 VAR1 ()
 in (Term.Var VAR)
end)
 in ( LrTable.NT 15, ( result, VAR1left, VAR1right), rest671)
end
|  ( 32, ( ( _, ( MlyValue.TERM TERM1, _, TERM1right)) :: _ :: ( _, ( 
MlyValue.TERMLIST TERMLIST1, TERMLIST1left, _)) :: rest671)) => let
 val  result = MlyValue.TERMLIST (fn _ => let val  (TERMLIST as 
TERMLIST1) = TERMLIST1 ()
 val  (TERM as TERM1) = TERM1 ()
 in (TERMLIST@[TERM])
end)
 in ( LrTable.NT 16, ( result, TERMLIST1left, TERM1right), rest671)

end
|  ( 33, ( ( _, ( MlyValue.TERM TERM1, TERM1left, TERM1right)) :: 
rest671)) => let val  result = MlyValue.TERMLIST (fn _ => let val  (
TERM as TERM1) = TERM1 ()
 in ([TERM])
end)
 in ( LrTable.NT 16, ( result, TERM1left, TERM1right), rest671)
end
|  ( 34, ( ( _, ( MlyValue.ID ID2, _, ID2right)) :: _ :: ( _, ( 
MlyValue.ID ID1, _, _)) :: ( _, ( _, QUESTION1left, _)) :: rest671))
 => let val  result = MlyValue.VAR (fn _ => let val  ID1 = ID1 ()
 val  ID2 = ID2 ()
 in ((Atom.atom ID1,0), Sort.fromString ID2)
end)
 in ( LrTable.NT 19, ( result, QUESTION1left, ID2right), rest671)
end
|  ( 35, ( ( _, ( MlyValue.ID ID1, _, ID1right)) :: ( _, ( _, 
QUESTION1left, _)) :: rest671)) => let val  result = MlyValue.VAR (fn
 _ => let val  ID1 = ID1 ()
 in ((Atom.atom ID1,0), Sort.null)
end)
 in ( LrTable.NT 19, ( result, QUESTION1left, ID1right), rest671)
end
|  ( 36, ( ( _, ( MlyValue.EQUALIST EQUALIST1, _, EQUALIST1right)) ::
 _ :: ( _, ( MlyValue.EQUA EQUA1, EQUA1left, _)) :: rest671)) => let
 val  result = MlyValue.EQUALIST (fn _ => let val  (EQUA as EQUA1) = 
EQUA1 ()
 val  (EQUALIST as EQUALIST1) = EQUALIST1 ()
 in (EQUA::EQUALIST)
end)
 in ( LrTable.NT 17, ( result, EQUA1left, EQUALIST1right), rest671)

end
|  ( 37, ( ( _, ( MlyValue.EQUA EQUA1, EQUA1left, EQUA1right)) :: 
rest671)) => let val  result = MlyValue.EQUALIST (fn _ => let val  (
EQUA as EQUA1) = EQUA1 ()
 in ([EQUA])
end)
 in ( LrTable.NT 17, ( result, EQUA1left, EQUA1right), rest671)
end
|  ( 38, ( rest671)) => let val  result = MlyValue.EQUALIST (fn _ => (
[]))
 in ( LrTable.NT 17, ( result, defaultPos, defaultPos), rest671)
end
|  ( 39, ( ( _, ( MlyValue.TERM TERM2, _, TERM2right)) :: _ :: ( _, ( 
MlyValue.TERM TERM1, TERM1left, _)) :: rest671)) => let val  result = 
MlyValue.EQUA (fn _ => let val  TERM1 = TERM1 ()
 val  TERM2 = TERM2 ()
 in ((TERM1,TERM2))
end)
 in ( LrTable.NT 18, ( result, TERM1left, TERM2right), rest671)
end
|  ( 40, ( ( _, ( MlyValue.PRECLIST PRECLIST1, _, PRECLIST1right)) ::
 _ :: ( _, ( MlyValue.PREC PREC1, PREC1left, _)) :: rest671)) => let
 val  result = MlyValue.PRECLIST (fn _ => let val  (PREC as PREC1) = 
PREC1 ()
 val  (PRECLIST as PRECLIST1) = PRECLIST1 ()
 in (PREC::map decreasePrec PRECLIST)
end)
 in ( LrTable.NT 20, ( result, PREC1left, PRECLIST1right), rest671)

end
|  ( 41, ( ( _, ( MlyValue.PRECLIST PRECLIST1, _, PRECLIST1right)) ::
 _ :: ( _, ( MlyValue.PREC PREC1, PREC1left, _)) :: rest671)) => let
 val  result = MlyValue.PRECLIST (fn _ => let val  (PREC as PREC1) = 
PREC1 ()
 val  (PRECLIST as PRECLIST1) = PRECLIST1 ()
 in (PREC::PRECLIST)
end)
 in ( LrTable.NT 20, ( result, PREC1left, PRECLIST1right), rest671)

end
|  ( 42, ( ( _, ( MlyValue.PREC PREC1, PREC1left, PREC1right)) :: 
rest671)) => let val  result = MlyValue.PRECLIST (fn _ => let val  (
PREC as PREC1) = PREC1 ()
 in ([PREC])
end)
 in ( LrTable.NT 20, ( result, PREC1left, PREC1right), rest671)
end
|  ( 43, ( rest671)) => let val  result = MlyValue.PRECLIST (fn _ => (
[]))
 in ( LrTable.NT 20, ( result, defaultPos, defaultPos), rest671)
end
|  ( 44, ( ( _, ( MlyValue.EX EX1, _, EX1right)) :: ( _, ( MlyValue.ID
 ID2, _, _)) :: _ :: ( _, ( MlyValue.ID ID1, ID1left, _)) :: rest671))
 => let val  result = MlyValue.PREC (fn _ => let val  ID1 = ID1 ()
 val  ID2 = ID2 ()
 val  (EX as EX1) = EX1 ()
 in ((0,Atom.atom ID1,Order.stringToRpoStatus ID2,EX))
end)
 in ( LrTable.NT 21, ( result, ID1left, EX1right), rest671)
end
|  ( 45, ( ( _, ( MlyValue.ID ID1, ID1left, ID1right)) :: rest671)) =>
 let val  result = MlyValue.PREC (fn _ => let val  ID1 = ID1 ()
 in ((0,Atom.atom ID1,Order.LEX,[]))
end)
 in ( LrTable.NT 21, ( result, ID1left, ID1right), rest671)
end
|  ( 46, ( ( _, ( MlyValue.NUMLIST NUMLIST1, _, NUMLIST1right)) :: ( _
, ( _, LBRACKET1left, _)) :: rest671)) => let val  result = 
MlyValue.EX (fn _ => let val  (NUMLIST as NUMLIST1) = NUMLIST1 ()
 in ((NUMLIST))
end)
 in ( LrTable.NT 22, ( result, LBRACKET1left, NUMLIST1right), rest671)

end
|  ( 47, ( rest671)) => let val  result = MlyValue.EX (fn _ => ([]))
 in ( LrTable.NT 22, ( result, defaultPos, defaultPos), rest671)
end
|  ( 48, ( ( _, ( MlyValue.NUMLIST NUMLIST1, _, NUMLIST1right)) :: _
 :: ( _, ( MlyValue.ID ID1, ID1left, _)) :: rest671)) => let val  
result = MlyValue.NUMLIST (fn _ => let val  (ID as ID1) = ID1 ()
 val  (NUMLIST as NUMLIST1) = NUMLIST1 ()
 in ((valOf (Int.fromString ID))::NUMLIST)
end)
 in ( LrTable.NT 23, ( result, ID1left, NUMLIST1right), rest671)
end
|  ( 49, ( ( _, ( _, _, RBRACKET1right)) :: ( _, ( MlyValue.ID ID1, 
ID1left, _)) :: rest671)) => let val  result = MlyValue.NUMLIST (fn _
 => let val  (ID as ID1) = ID1 ()
 in ([valOf (Int.fromString ID)])
end)
 in ( LrTable.NT 23, ( result, ID1left, RBRACKET1right), rest671)
end
|  ( 50, ( ( _, ( _, RBRACKET1left, RBRACKET1right)) :: rest671)) =>
 let val  result = MlyValue.NUMLIST (fn _ => ([]))
 in ( LrTable.NT 23, ( result, RBRACKET1left, RBRACKET1right), rest671
)
end
|  ( 51, ( ( _, ( MlyValue.POLYLIST POLYLIST1, _, POLYLIST1right)) ::
 _ :: ( _, ( MlyValue.FUN_POLY FUN_POLY1, FUN_POLY1left, _)) :: 
rest671)) => let val  result = MlyValue.POLYLIST (fn _ => let val  (
FUN_POLY as FUN_POLY1) = FUN_POLY1 ()
 val  (POLYLIST as POLYLIST1) = POLYLIST1 ()
 in (FUN_POLY::POLYLIST)
end)
 in ( LrTable.NT 24, ( result, FUN_POLY1left, POLYLIST1right), rest671
)
end
|  ( 52, ( rest671)) => let val  result = MlyValue.POLYLIST (fn _ => (
[]))
 in ( LrTable.NT 24, ( result, defaultPos, defaultPos), rest671)
end
|  ( 53, ( ( _, ( MlyValue.MONOLIST MONOLIST1, _, MONOLIST1right)) ::
 _ :: _ :: ( _, ( MlyValue.VARLIST VARLIST1, _, _)) :: _ :: _ :: ( _, 
( MlyValue.ID ID1, _, _)) :: ( _, ( _, LBRACKET1left, _)) :: rest671))
 => let val  result = MlyValue.FUN_POLY (fn _ => let val  (ID as ID1)
 = ID1 ()
 val  (VARLIST as VARLIST1) = VARLIST1 ()
 val  (MONOLIST as MONOLIST1) = MONOLIST1 ()
 in (Fun.fromString ID, toPoly VARLIST (Plus MONOLIST))
end)
 in ( LrTable.NT 25, ( result, LBRACKET1left, MONOLIST1right), rest671
)
end
|  ( 54, ( ( _, ( MlyValue.MONOLIST MONOLIST1, _, MONOLIST1right)) ::
 _ :: _ :: ( _, ( MlyValue.ID ID1, _, _)) :: ( _, ( _, LBRACKET1left,
 _)) :: rest671)) => let val  result = MlyValue.FUN_POLY (fn _ => let
 val  (ID as ID1) = ID1 ()
 val  (MONOLIST as MONOLIST1) = MONOLIST1 ()
 in (Fun.fromString ID, toPoly [] (Plus MONOLIST))
end)
 in ( LrTable.NT 25, ( result, LBRACKET1left, MONOLIST1right), rest671
)
end
|  ( 55, ( ( _, ( MlyValue.VARLIST VARLIST1, _, VARLIST1right)) :: _
 :: ( _, ( MlyValue.ID ID1, ID1left, _)) :: rest671)) => let val  
result = MlyValue.VARLIST (fn _ => let val  (ID as ID1) = ID1 ()
 val  (VARLIST as VARLIST1) = VARLIST1 ()
 in (ID::VARLIST)
end)
 in ( LrTable.NT 26, ( result, ID1left, VARLIST1right), rest671)
end
|  ( 56, ( ( _, ( MlyValue.ID ID1, ID1left, ID1right)) :: rest671)) =>
 let val  result = MlyValue.VARLIST (fn _ => let val  (ID as ID1) = 
ID1 ()
 in ([ID])
end)
 in ( LrTable.NT 26, ( result, ID1left, ID1right), rest671)
end
|  ( 57, ( rest671)) => let val  result = MlyValue.VARLIST (fn _ => (
[]))
 in ( LrTable.NT 26, ( result, defaultPos, defaultPos), rest671)
end
|  ( 58, ( ( _, ( MlyValue.MONOLIST MONOLIST1, _, MONOLIST1right)) ::
 _ :: ( _, ( MlyValue.AEXPLIST AEXPLIST1, AEXPLIST1left, _)) :: 
rest671)) => let val  result = MlyValue.MONOLIST (fn _ => let val  (
AEXPLIST as AEXPLIST1) = AEXPLIST1 ()
 val  (MONOLIST as MONOLIST1) = MONOLIST1 ()
 in ((Times AEXPLIST)::MONOLIST)
end)
 in ( LrTable.NT 27, ( result, AEXPLIST1left, MONOLIST1right), rest671
)
end
|  ( 59, ( ( _, ( MlyValue.AEXPLIST AEXPLIST1, AEXPLIST1left, 
AEXPLIST1right)) :: rest671)) => let val  result = MlyValue.MONOLIST
 (fn _ => let val  (AEXPLIST as AEXPLIST1) = AEXPLIST1 ()
 in ([Times AEXPLIST])
end)
 in ( LrTable.NT 27, ( result, AEXPLIST1left, AEXPLIST1right), rest671
)
end
|  ( 60, ( ( _, ( MlyValue.AEXPLIST AEXPLIST1, _, AEXPLIST1right)) ::
 _ :: ( _, ( MlyValue.AEXP AEXP1, AEXP1left, _)) :: rest671)) => let
 val  result = MlyValue.AEXPLIST (fn _ => let val  (AEXP as AEXP1) = 
AEXP1 ()
 val  (AEXPLIST as AEXPLIST1) = AEXPLIST1 ()
 in (AEXP::AEXPLIST)
end)
 in ( LrTable.NT 29, ( result, AEXP1left, AEXPLIST1right), rest671)

end
|  ( 61, ( ( _, ( MlyValue.AEXP AEXP1, AEXP1left, AEXP1right)) :: 
rest671)) => let val  result = MlyValue.AEXPLIST (fn _ => let val  (
AEXP as AEXP1) = AEXP1 ()
 in ([AEXP])
end)
 in ( LrTable.NT 29, ( result, AEXP1left, AEXP1right), rest671)
end
|  ( 62, ( ( _, ( MlyValue.ID ID1, ID1left, ID1right)) :: rest671)) =>
 let val  result = MlyValue.AEXP (fn _ => let val  (ID as ID1) = ID1
 ()
 in (toAexp ID)
end)
 in ( LrTable.NT 30, ( result, ID1left, ID1right), rest671)
end
|  ( 63, ( ( _, ( _, _, RPAREN1right)) :: ( _, ( MlyValue.MONOLIST 
MONOLIST1, _, _)) :: ( _, ( _, LPAREN1left, _)) :: rest671)) => let
 val  result = MlyValue.AEXP (fn _ => let val  (MONOLIST as MONOLIST1)
 = MONOLIST1 ()
 in (Poly (Plus MONOLIST))
end)
 in ( LrTable.NT 30, ( result, LPAREN1left, RPAREN1right), rest671)

end
|  ( 64, ( ( _, ( MlyValue.KBOPRECLIST KBOPRECLIST1, _, 
KBOPRECLIST1right)) :: _ :: ( _, ( MlyValue.KBOPREC KBOPREC1, 
KBOPREC1left, _)) :: rest671)) => let val  result = 
MlyValue.KBOPRECLIST (fn _ => let val  (KBOPREC as KBOPREC1) = 
KBOPREC1 ()
 val  (KBOPRECLIST as KBOPRECLIST1) = KBOPRECLIST1 ()
 in (KBOPREC::map decreaseKboPrec KBOPRECLIST)
end)
 in ( LrTable.NT 32, ( result, KBOPREC1left, KBOPRECLIST1right), 
rest671)
end
|  ( 65, ( ( _, ( MlyValue.KBOPRECLIST KBOPRECLIST1, _, 
KBOPRECLIST1right)) :: _ :: ( _, ( MlyValue.KBOPREC KBOPREC1, 
KBOPREC1left, _)) :: rest671)) => let val  result = 
MlyValue.KBOPRECLIST (fn _ => let val  (KBOPREC as KBOPREC1) = 
KBOPREC1 ()
 val  (KBOPRECLIST as KBOPRECLIST1) = KBOPRECLIST1 ()
 in (KBOPREC::KBOPRECLIST)
end)
 in ( LrTable.NT 32, ( result, KBOPREC1left, KBOPRECLIST1right), 
rest671)
end
|  ( 66, ( ( _, ( MlyValue.KBOPREC KBOPREC1, KBOPREC1left, 
KBOPREC1right)) :: rest671)) => let val  result = MlyValue.KBOPRECLIST
 (fn _ => let val  (KBOPREC as KBOPREC1) = KBOPREC1 ()
 in ([KBOPREC])
end)
 in ( LrTable.NT 32, ( result, KBOPREC1left, KBOPREC1right), rest671)

end
|  ( 67, ( rest671)) => let val  result = MlyValue.KBOPRECLIST (fn _
 => ([]))
 in ( LrTable.NT 32, ( result, defaultPos, defaultPos), rest671)
end
|  ( 68, ( ( _, ( MlyValue.EX EX1, _, EX1right)) :: ( _, ( MlyValue.ID
 ID3, _, _)) :: _ :: ( _, ( MlyValue.ID ID2, _, _)) :: _ :: ( _, ( 
MlyValue.ID ID1, ID1left, _)) :: rest671)) => let val  result = 
MlyValue.KBOPREC (fn _ => let val  ID1 = ID1 ()
 val  ID2 = ID2 ()
 val  ID3 = ID3 ()
 val  (EX as EX1) = EX1 ()
 in ((false,0,Atom.atom ID1,Int.fromString ID2,EX))
end)
 in ( LrTable.NT 33, ( result, ID1left, EX1right), rest671)
end
|  ( 69, ( ( _, ( MlyValue.ID ID2, _, ID2right)) :: _ :: ( _, ( 
MlyValue.ID ID1, ID1left, _)) :: rest671)) => let val  result = 
MlyValue.KBOPREC (fn _ => let val  ID1 = ID1 ()
 val  ID2 = ID2 ()
 in ((false,0,Atom.atom ID1,Int.fromString ID2,[]))
end)
 in ( LrTable.NT 33, ( result, ID1left, ID2right), rest671)
end
|  ( 70, ( ( _, ( MlyValue.ID ID2, _, ID2right)) :: _ :: _ :: ( _, ( 
MlyValue.ID ID1, _, _)) :: ( _, ( _, LPAREN1left, _)) :: rest671)) =>
 let val  result = MlyValue.KBOPREC (fn _ => let val  ID1 = ID1 ()
 val  ID2 = ID2 ()
 in ((true,0,Atom.atom ID1,Int.fromString ID2,[]))
end)
 in ( LrTable.NT 33, ( result, LPAREN1left, ID2right), rest671)
end
| _ => raise (mlyAction i392)
end
val void = MlyValue.VOID
val extract = fn a => (fn MlyValue.START x => x
| _ => let exception ParseInternal
	in raise ParseInternal end) a ()
end
end
structure Tokens : Spec_TOKENS =
struct
type svalue = ParserData.svalue
type ('a,'b) token = ('a,'b) Token.token
fun ID (i,p1,p2) = Token.TOKEN (ParserData.LrTable.T 0,(
ParserData.MlyValue.ID (fn () => i),p1,p2))
fun SEMICOLON (p1,p2) = Token.TOKEN (ParserData.LrTable.T 1,(
ParserData.MlyValue.VOID,p1,p2))
fun COLON (p1,p2) = Token.TOKEN (ParserData.LrTable.T 2,(
ParserData.MlyValue.VOID,p1,p2))
fun THINARROW (p1,p2) = Token.TOKEN (ParserData.LrTable.T 3,(
ParserData.MlyValue.VOID,p1,p2))
fun TIMES (p1,p2) = Token.TOKEN (ParserData.LrTable.T 4,(
ParserData.MlyValue.VOID,p1,p2))
fun PLUS (p1,p2) = Token.TOKEN (ParserData.LrTable.T 5,(
ParserData.MlyValue.VOID,p1,p2))
fun LPAREN (p1,p2) = Token.TOKEN (ParserData.LrTable.T 6,(
ParserData.MlyValue.VOID,p1,p2))
fun RPAREN (p1,p2) = Token.TOKEN (ParserData.LrTable.T 7,(
ParserData.MlyValue.VOID,p1,p2))
fun COM (p1,p2) = Token.TOKEN (ParserData.LrTable.T 8,(
ParserData.MlyValue.VOID,p1,p2))
fun EQ (p1,p2) = Token.TOKEN (ParserData.LrTable.T 9,(
ParserData.MlyValue.VOID,p1,p2))
fun LBRACKET (p1,p2) = Token.TOKEN (ParserData.LrTable.T 10,(
ParserData.MlyValue.VOID,p1,p2))
fun RBRACKET (p1,p2) = Token.TOKEN (ParserData.LrTable.T 11,(
ParserData.MlyValue.VOID,p1,p2))
fun QUESTION (p1,p2) = Token.TOKEN (ParserData.LrTable.T 12,(
ParserData.MlyValue.VOID,p1,p2))
fun SORTS (p1,p2) = Token.TOKEN (ParserData.LrTable.T 13,(
ParserData.MlyValue.VOID,p1,p2))
fun RULES (p1,p2) = Token.TOKEN (ParserData.LrTable.T 14,(
ParserData.MlyValue.VOID,p1,p2))
fun EQUATIONS (p1,p2) = Token.TOKEN (ParserData.LrTable.T 15,(
ParserData.MlyValue.VOID,p1,p2))
fun CONJECTURES (p1,p2) = Token.TOKEN (ParserData.LrTable.T 16,(
ParserData.MlyValue.VOID,p1,p2))
fun PRECEDENCE (p1,p2) = Token.TOKEN (ParserData.LrTable.T 17,(
ParserData.MlyValue.VOID,p1,p2))
fun POLYNOMIALS (p1,p2) = Token.TOKEN (ParserData.LrTable.T 18,(
ParserData.MlyValue.VOID,p1,p2))
fun KBOSPECIFICATION (p1,p2) = Token.TOKEN (ParserData.LrTable.T 19,(
ParserData.MlyValue.VOID,p1,p2))
fun EOF (p1,p2) = Token.TOKEN (ParserData.LrTable.T 20,(
ParserData.MlyValue.VOID,p1,p2))
end
end
