(******************************************************************************
 * file: rwtools/stsrs/io_stspec.sml
 * description: Interface to Spec. File for Termination Checker
 * author: AOTO Takahito
 * 
 * Copyright (c) 2008, Toyama&Aoto Laboratory, Tohoku University
 ******************************************************************************)

signature IO_STSPEC =  
  sig
      type yaccexpr = Atom.atom list 
		      * (Atom.atom * Sort.sort) list 
		      * (Term.term * Term.term) list 
      val rdFile: string -> yaccexpr;
  end;


structure IOStspec : IO_STSPEC =  
  struct
  
   type yaccexpr = Atom.atom list 
		   * (Atom.atom * Sort.sort) list 
		   * (Term.term * Term.term ) list 

   structure StspecLrVals = StspecLrValsFun (structure Token = LrParser.Token);
   structure StspecLex = StspecLexFun (structure Tokens = StspecLrVals.Tokens);
   structure StspecParser = 
   Join (structure ParserData = StspecLrVals.ParserData;
   structure Lex = StspecLex;
   structure LrParser = LrParser);

   (* ʸϤؿ: ȥ꡼ࢪʸ *)
   fun parserStream istream = 
       let val lexer = StspecParser.makeLexer 
			   (fn n=>TextIO.inputN (istream, n));
	   val print_error = fn (s, i, _) => 
				print (s^", line " ^ Int.toString(i) ^ "\n");
       in #1 (StspecParser.parse (0, lexer, print_error, ()))
       end;

   (* ʸϤؿ: ե̾ʸ *)
   fun rdFile filename = parserStream (TextIO.openIn filename);

			
  end;




